/* WifiInterface.c generated by valac 0.56.2, the Vala compiler
 * generated from WifiInterface.vala, do not modify */

/*
* Copyright 2015-2021 elementary, Inc. (https://elementary.io)
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU Library General Public License as published by
* the Free Software Foundation, either version 2.1 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Library General Public License for more details.
*
* You should have received a copy of the GNU Library General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
*
*/

#include "network.h"
#include <NetworkManager.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <granite.h>
#include <gtk/gtk.h>
#include <gio/gio.h>
#include <glib-object.h>
#include <glib/gi18n-lib.h>
#include <nma-wifi-dialog.h>
#include <pango/pango.h>

enum  {
	NETWORK_WIFI_INTERFACE_0_PROPERTY,
	NETWORK_WIFI_INTERFACE_NM_CLIENT_PROPERTY,
	NETWORK_WIFI_INTERFACE_HIDDEN_SENSITIVITY_PROPERTY,
	NETWORK_WIFI_INTERFACE_ACTIVE_AP_NAME_PROPERTY,
	NETWORK_WIFI_INTERFACE_NUM_PROPERTIES
};
static GParamSpec* network_wifi_interface_properties[NETWORK_WIFI_INTERFACE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block5Data Block5Data;
#define _g_ptr_array_unref0(var) ((var == NULL) ? NULL : (var = (g_ptr_array_unref (var), NULL)))
#define _rf_kill_device_unref0(var) ((var == NULL) ? NULL : (var = (rf_kill_device_unref (var), NULL)))
typedef struct _Block6Data Block6Data;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _Block7Data Block7Data;
typedef struct _Block8Data Block8Data;
typedef struct _NetworkWifiInterfaceConnectToNetworkData NetworkWifiInterfaceConnectToNetworkData;
#define _g_bytes_unref0(var) ((var == NULL) ? NULL : (var = (g_bytes_unref (var), NULL)))

#define NETWORK_WIFI_INTERFACE_TYPE_PLACEHOLDER_LABEL (network_wifi_interface_placeholder_label_get_type ())
#define NETWORK_WIFI_INTERFACE_PLACEHOLDER_LABEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NETWORK_WIFI_INTERFACE_TYPE_PLACEHOLDER_LABEL, NetworkWifiInterfacePlaceholderLabel))
#define NETWORK_WIFI_INTERFACE_PLACEHOLDER_LABEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NETWORK_WIFI_INTERFACE_TYPE_PLACEHOLDER_LABEL, NetworkWifiInterfacePlaceholderLabelClass))
#define NETWORK_WIFI_INTERFACE_IS_PLACEHOLDER_LABEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NETWORK_WIFI_INTERFACE_TYPE_PLACEHOLDER_LABEL))
#define NETWORK_WIFI_INTERFACE_IS_PLACEHOLDER_LABEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NETWORK_WIFI_INTERFACE_TYPE_PLACEHOLDER_LABEL))
#define NETWORK_WIFI_INTERFACE_PLACEHOLDER_LABEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NETWORK_WIFI_INTERFACE_TYPE_PLACEHOLDER_LABEL, NetworkWifiInterfacePlaceholderLabelClass))

typedef struct _NetworkWifiInterfacePlaceholderLabel NetworkWifiInterfacePlaceholderLabel;
typedef struct _NetworkWifiInterfacePlaceholderLabelClass NetworkWifiInterfacePlaceholderLabelClass;
typedef struct _NetworkWifiInterfacePlaceholderLabelPrivate NetworkWifiInterfacePlaceholderLabelPrivate;
enum  {
	NETWORK_WIFI_INTERFACE_PLACEHOLDER_LABEL_0_PROPERTY,
	NETWORK_WIFI_INTERFACE_PLACEHOLDER_LABEL_NUM_PROPERTIES
};
static GParamSpec* network_wifi_interface_placeholder_label_properties[NETWORK_WIFI_INTERFACE_PLACEHOLDER_LABEL_NUM_PROPERTIES];
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _NetworkWifiInterfacePrivate {
	NMClient* _nm_client;
	gboolean _hidden_sensitivity;
	gchar* _active_ap_name;
	GraniteSwitchModelButton* wifi_item;
	GtkRevealer* revealer;
	RFKillManager* rfkill;
	NMAccessPoint* active_ap;
	GtkListBox* wifi_list;
	NetworkWifiMenuItem* active_wifi_item;
	NetworkWifiMenuItem* blank_item;
	GtkStack* placeholder;
	gboolean locked;
	gboolean software_locked;
	gboolean hardware_locked;
	guint timeout_scan;
	GCancellable* wifi_scan_cancellable;
};

struct _Block5Data {
	int _ref_count_;
	NetworkWifiInterface* self;
	NMClient* nm_client;
};

struct _Block6Data {
	int _ref_count_;
	NetworkWifiInterface* self;
	NMAWifiDialog* wifi_dialog;
};

struct _Block7Data {
	int _ref_count_;
	NetworkWifiInterface* self;
	NMAWifiDialog* hidden_dialog;
};

struct _Block8Data {
	int _ref_count_;
	NetworkWifiInterface* self;
	NMConnection* fuzzy;
	NMConnection* dialog_connection;
	gpointer _async_data_;
};

struct _NetworkWifiInterfaceConnectToNetworkData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	NetworkWifiInterface* self;
	NMAWifiDialog* wifi_dialog;
	Block8Data* _data8_;
	NMDevice* dialog_device;
	NMAccessPoint* dialog_ap;
	NMDevice* _tmp0_;
	NMAccessPoint* _tmp1_;
	NMConnection* _tmp2_;
	NMClient* _tmp3_;
	GPtrArray* _tmp4_;
	gchar* path;
	NMAccessPoint* _tmp5_;
	NMAccessPoint* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	NMConnection* _tmp9_;
	NMClient* _tmp10_;
	NMConnection* _tmp11_;
	NMDeviceWifi* _tmp12_;
	const gchar* _tmp13_;
	NMActiveConnection* _tmp14_;
	NMActiveConnection* _tmp15_;
	GError* _error_;
	GError* _tmp16_;
	const gchar* _tmp17_;
	gchar* mode;
	NMSettingWireless* setting_wireless;
	NMConnection* _tmp18_;
	NMSettingWireless* _tmp19_;
	NMSettingWireless* _tmp20_;
	NMSettingWireless* _tmp21_;
	const gchar* _tmp22_;
	gchar* _tmp23_;
	const gchar* _tmp24_;
	NMSettingConnection* connection_setting;
	NMConnection* _tmp25_;
	NMSettingConnection* _tmp26_;
	NMSettingConnection* _tmp27_;
	NMSettingConnection* _tmp28_;
	NMSettingConnection* _tmp29_;
	NMConnection* _tmp30_;
	NMSettingConnection* _tmp31_;
	NMSetting* _tmp32_;
	NMClient* _tmp33_;
	NMConnection* _tmp34_;
	NMDevice* _tmp35_;
	const gchar* _tmp36_;
	NMActiveConnection* _tmp37_;
	NMActiveConnection* _tmp38_;
	GError* _vala1__error_;
	GError* _tmp39_;
	const gchar* _tmp40_;
	GError* _inner_error0_;
};

struct _NetworkWifiInterfacePlaceholderLabel {
	GtkLabel parent_instance;
	NetworkWifiInterfacePlaceholderLabelPrivate * priv;
};

struct _NetworkWifiInterfacePlaceholderLabelClass {
	GtkLabelClass parent_class;
};

static gint NetworkWifiInterface_private_offset;
static gpointer network_wifi_interface_parent_class = NULL;
static gpointer network_wifi_interface_placeholder_label_parent_class = NULL;

static Block5Data* block5_data_ref (Block5Data* _data5_);
static void block5_data_unref (void * _userdata_);
static void _network_widget_nm_interface_update_rf_kill_manager_device_added (RFKillManager* _sender,
                                                                       RFKillDevice* device,
                                                                       gpointer self);
static void _network_widget_nm_interface_update_rf_kill_manager_device_changed (RFKillManager* _sender,
                                                                         RFKillDevice* device,
                                                                         gpointer self);
static void _network_widget_nm_interface_update_rf_kill_manager_device_deleted (RFKillManager* _sender,
                                                                         RFKillDevice* device,
                                                                         gpointer self);
static void _network_widget_nm_interface_update_g_object_notify (GObject* _sender,
                                                          GParamSpec* pspec,
                                                          gpointer self);
static void network_wifi_interface_access_point_added_cb (NetworkWifiInterface* self,
                                                   GObject* ap_);
static void _network_wifi_interface_access_point_added_cb_nm_device_wifi_access_point_added (NMDeviceWifi* _sender,
                                                                                      GObject* ap,
                                                                                      gpointer self);
static void network_wifi_interface_access_point_removed_cb (NetworkWifiInterface* self,
                                                     GObject* ap_);
static void _network_wifi_interface_access_point_removed_cb_nm_device_wifi_access_point_removed (NMDeviceWifi* _sender,
                                                                                          GObject* ap,
                                                                                          gpointer self);
static void _network_widget_nm_interface_update_nm_device_state_changed (NMDevice* _sender,
                                                                  guint new_state,
                                                                  guint old_state,
                                                                  guint reason,
                                                                  gpointer self);
static void _network_wifi_interface_access_point_added_cb_gfunc (gconstpointer data,
                                                          gpointer self);
static void __lambda13_ (NetworkWifiInterface* self);
static void ___lambda13__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
static void __lambda14_ (Block5Data* _data5_);
static void ___lambda14__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
static void network_wifi_interface_real_update_name (NetworkWidgetNMInterface* base,
                                              gint count);
static void network_wifi_interface_real_update (NetworkWidgetNMInterface* base);
static void network_wifi_interface_cancel_scan (NetworkWifiInterface* self);
static void network_wifi_interface_set_scan_placeholder (NetworkWifiInterface* self);
static NetworkState network_wifi_interface_strength_to_state (NetworkWifiInterface* self,
                                                       guint8 strength);
static void _rf_kill_device_unref0_ (gpointer var);
static inline void _g_list_free__rf_kill_device_unref0_ (GList* self);
static void network_wifi_interface_update_active_ap (NetworkWifiInterface* self);
static void network_wifi_interface_wifi_activate_cb (NetworkWifiInterface* self,
                                              NetworkWifiMenuItem* i);
static NMConnection* network_wifi_interface_get_valid_connection (NetworkWifiInterface* self,
                                                           NMAccessPoint* ap,
                                                           GPtrArray* ap_connections);
static Block6Data* block6_data_ref (Block6Data* _data6_);
static void block6_data_unref (void * _userdata_);
static void ___lambda9_ (Block6Data* _data6_,
                  gint response);
static void network_wifi_interface_connect_to_network (NetworkWifiInterface* self,
                                                NMAWifiDialog* wifi_dialog,
                                                GAsyncReadyCallback _callback_,
                                                gpointer _user_data_);
static void network_wifi_interface_connect_to_network_finish (NetworkWifiInterface* self,
                                                       GAsyncResult* _res_);
static void ____lambda9__gtk_dialog_response (GtkDialog* _sender,
                                       gint response_id,
                                       gpointer self);
static void ___lambda11_ (NetworkWifiInterface* self,
                   GObject* obj,
                   GAsyncResult* res);
static void ____lambda11__gasync_ready_callback (GObject* source_object,
                                          GAsyncResult* res,
                                          gpointer self);
static gboolean __lambda12_ (NetworkWifiInterface* self);
static gboolean ___lambda12__gsource_func (gpointer self);
static Block7Data* block7_data_ref (Block7Data* _data7_);
static void block7_data_unref (void * _userdata_);
static void __lambda15_ (Block7Data* _data7_,
                  gint response);
static void ___lambda15__gtk_dialog_response (GtkDialog* _sender,
                                       gint response_id,
                                       gpointer self);
static void network_wifi_interface_connect_to_network_data_free (gpointer _data);
static gboolean network_wifi_interface_connect_to_network_co (NetworkWifiInterfaceConnectToNetworkData* _data_);
static Block8Data* block8_data_ref (Block8Data* _data8_);
static void block8_data_unref (void * _userdata_);
static void __lambda10_ (Block8Data* _data8_,
                  NMRemoteConnection* possible);
static void ___lambda10__gfunc (gconstpointer data,
                         gpointer self);
static void network_wifi_interface_connect_to_network_ready (GObject* source_object,
                                                      GAsyncResult* _res_,
                                                      gpointer _user_data_);
static void _network_wifi_interface_wifi_activate_cb_network_wifi_menu_item_user_action (NetworkWifiMenuItem* _sender,
                                                                                  gpointer self);
static void network_wifi_interface_set_active_ap_name (NetworkWifiInterface* self,
                                                const gchar* value);
static gboolean ___lambda8_ (NetworkWifiInterface* self);
static gboolean ____lambda8__gsource_func (gpointer self);
static gint network_wifi_interface_sort_func (NetworkWifiInterface* self,
                                       GtkListBoxRow* r1,
                                       GtkListBoxRow* r2);
static GType network_wifi_interface_placeholder_label_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static NetworkWifiInterfacePlaceholderLabel* network_wifi_interface_placeholder_label_new (const gchar* label);
static NetworkWifiInterfacePlaceholderLabel* network_wifi_interface_placeholder_label_construct (GType object_type,
                                                                                          const gchar* label);
static GObject * network_wifi_interface_placeholder_label_constructor (GType type,
                                                                guint n_construct_properties,
                                                                GObjectConstructParam * construct_properties);
static GType network_wifi_interface_placeholder_label_get_type_once (void);
static GObject * network_wifi_interface_constructor (GType type,
                                              guint n_construct_properties,
                                              GObjectConstructParam * construct_properties);
static gint _network_wifi_interface_sort_func_gtk_list_box_sort_func (GtkListBoxRow* row1,
                                                               GtkListBoxRow* row2,
                                                               gpointer self);
static void network_wifi_interface_finalize (GObject * obj);
static GType network_wifi_interface_get_type_once (void);
static void _vala_network_wifi_interface_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec);
static void _vala_network_wifi_interface_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec);

static inline gpointer
network_wifi_interface_get_instance_private (NetworkWifiInterface* self)
{
	return G_STRUCT_MEMBER_P (self, NetworkWifiInterface_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static Block5Data*
block5_data_ref (Block5Data* _data5_)
{
	g_atomic_int_inc (&_data5_->_ref_count_);
	return _data5_;
}

static void
block5_data_unref (void * _userdata_)
{
	Block5Data* _data5_;
	_data5_ = (Block5Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data5_->_ref_count_)) {
		NetworkWifiInterface* self;
		self = _data5_->self;
		_g_object_unref0 (_data5_->nm_client);
		_g_object_unref0 (self);
		g_slice_free (Block5Data, _data5_);
	}
}

static void
_network_widget_nm_interface_update_rf_kill_manager_device_added (RFKillManager* _sender,
                                                                  RFKillDevice* device,
                                                                  gpointer self)
{
	network_widget_nm_interface_update ((NetworkWidgetNMInterface*) self);
}

static void
_network_widget_nm_interface_update_rf_kill_manager_device_changed (RFKillManager* _sender,
                                                                    RFKillDevice* device,
                                                                    gpointer self)
{
	network_widget_nm_interface_update ((NetworkWidgetNMInterface*) self);
}

static void
_network_widget_nm_interface_update_rf_kill_manager_device_deleted (RFKillManager* _sender,
                                                                    RFKillDevice* device,
                                                                    gpointer self)
{
	network_widget_nm_interface_update ((NetworkWidgetNMInterface*) self);
}

static void
_network_widget_nm_interface_update_g_object_notify (GObject* _sender,
                                                     GParamSpec* pspec,
                                                     gpointer self)
{
	network_widget_nm_interface_update ((NetworkWidgetNMInterface*) self);
}

static void
_network_wifi_interface_access_point_added_cb_nm_device_wifi_access_point_added (NMDeviceWifi* _sender,
                                                                                 GObject* ap,
                                                                                 gpointer self)
{
	network_wifi_interface_access_point_added_cb ((NetworkWifiInterface*) self, ap);
}

static void
_network_wifi_interface_access_point_removed_cb_nm_device_wifi_access_point_removed (NMDeviceWifi* _sender,
                                                                                     GObject* ap,
                                                                                     gpointer self)
{
	network_wifi_interface_access_point_removed_cb ((NetworkWifiInterface*) self, ap);
}

static void
_network_widget_nm_interface_update_nm_device_state_changed (NMDevice* _sender,
                                                             guint new_state,
                                                             guint old_state,
                                                             guint reason,
                                                             gpointer self)
{
	network_widget_nm_interface_update ((NetworkWidgetNMInterface*) self);
}

static gpointer
_g_ptr_array_ref0 (gpointer self)
{
	return self ? g_ptr_array_ref (self) : NULL;
}

static gint
vala_g_ptr_array_get_length (GPtrArray* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = (gint) self->len;
	return result;
}

static void
_network_wifi_interface_access_point_added_cb_gfunc (gconstpointer data,
                                                     gpointer self)
{
	network_wifi_interface_access_point_added_cb ((NetworkWifiInterface*) self, (GObject*) data);
}

static void
__lambda13_ (NetworkWifiInterface* self)
{
	GraniteSwitchModelButton* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	_tmp0_ = self->priv->wifi_item;
	_tmp1_ = network_widget_nm_interface_get_display_title ((NetworkWidgetNMInterface*) self);
	_tmp2_ = _tmp1_;
	granite_switch_model_button_set_text (_tmp0_, _tmp2_);
}

static void
___lambda13__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
	__lambda13_ ((NetworkWifiInterface*) self);
}

static void
__lambda14_ (Block5Data* _data5_)
{
	NetworkWifiInterface* self;
	gboolean active = FALSE;
	GraniteSwitchModelButton* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	self = _data5_->self;
	_tmp0_ = self->priv->wifi_item;
	_tmp1_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp0_);
	_tmp2_ = _tmp1_;
	active = _tmp2_;
	if (active != (!self->priv->software_locked)) {
		RFKillManager* _tmp3_;
		_tmp3_ = self->priv->rfkill;
		rf_kill_manager_set_software_lock (_tmp3_, RF_KILL_DEVICE_TYPE_WLAN, !active);
		nm_client_wireless_set_enabled (_data5_->nm_client, active);
	}
}

static void
___lambda14__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
	__lambda14_ (self);
}

NetworkWifiInterface*
network_wifi_interface_construct (GType object_type,
                                  NMClient* nm_client,
                                  NMDevice* _device)
{
	NetworkWifiInterface * self = NULL;
	Block5Data* _data5_;
	NMClient* _tmp0_;
	NMDevice* _tmp1_;
	NMDevice* _tmp2_;
	NMDeviceWifi* _tmp3_;
	NetworkWifiMenuItem* _tmp4_;
	RFKillManager* _tmp5_;
	RFKillManager* _tmp6_;
	RFKillManager* _tmp7_;
	RFKillManager* _tmp8_;
	RFKillManager* _tmp9_;
	NMDeviceWifi* _tmp10_;
	NMDeviceWifi* _tmp11_;
	NMDeviceWifi* _tmp12_;
	NMDeviceWifi* _tmp13_;
	GPtrArray* aps = NULL;
	NMDeviceWifi* _tmp14_;
	GPtrArray* _tmp15_;
	GPtrArray* _tmp16_;
	gboolean _tmp17_ = FALSE;
	GPtrArray* _tmp18_;
	GraniteSwitchModelButton* _tmp23_;
	const gchar* _tmp24_;
	const gchar* _tmp25_;
	GraniteSwitchModelButton* _tmp26_;
	g_return_val_if_fail (nm_client != NULL, NULL);
	_data5_ = g_slice_new0 (Block5Data);
	_data5_->_ref_count_ = 1;
	_tmp0_ = _g_object_ref0 (nm_client);
	_g_object_unref0 (_data5_->nm_client);
	_data5_->nm_client = _tmp0_;
	self = (NetworkWifiInterface*) g_object_new (object_type, "nm-client", _data5_->nm_client, NULL);
	_data5_->self = g_object_ref (self);
	_tmp1_ = _g_object_ref0 (_device);
	_g_object_unref0 (((NetworkWidgetNMInterface*) self)->device);
	((NetworkWidgetNMInterface*) self)->device = _tmp1_;
	_tmp2_ = ((NetworkWidgetNMInterface*) self)->device;
	_tmp3_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, nm_device_wifi_get_type (), NMDeviceWifi));
	_g_object_unref0 (self->wifi_device);
	self->wifi_device = _tmp3_;
	_tmp4_ = network_wifi_menu_item_new_blank ();
	g_object_ref_sink (_tmp4_);
	_g_object_unref0 (self->priv->blank_item);
	self->priv->blank_item = _tmp4_;
	_g_object_unref0 (self->priv->active_wifi_item);
	self->priv->active_wifi_item = NULL;
	_tmp5_ = rf_kill_manager_new ();
	_g_object_unref0 (self->priv->rfkill);
	self->priv->rfkill = _tmp5_;
	_tmp6_ = self->priv->rfkill;
	rf_kill_manager_open (_tmp6_);
	_tmp7_ = self->priv->rfkill;
	g_signal_connect_object (_tmp7_, "device-added", (GCallback) _network_widget_nm_interface_update_rf_kill_manager_device_added, (NetworkWidgetNMInterface*) self, 0);
	_tmp8_ = self->priv->rfkill;
	g_signal_connect_object (_tmp8_, "device-changed", (GCallback) _network_widget_nm_interface_update_rf_kill_manager_device_changed, (NetworkWidgetNMInterface*) self, 0);
	_tmp9_ = self->priv->rfkill;
	g_signal_connect_object (_tmp9_, "device-deleted", (GCallback) _network_widget_nm_interface_update_rf_kill_manager_device_deleted, (NetworkWidgetNMInterface*) self, 0);
	_tmp10_ = self->wifi_device;
	g_signal_connect_object ((GObject*) _tmp10_, "notify::active-access-point", (GCallback) _network_widget_nm_interface_update_g_object_notify, (NetworkWidgetNMInterface*) self, 0);
	_tmp11_ = self->wifi_device;
	g_signal_connect_object (_tmp11_, "access-point-added", (GCallback) _network_wifi_interface_access_point_added_cb_nm_device_wifi_access_point_added, self, 0);
	_tmp12_ = self->wifi_device;
	g_signal_connect_object (_tmp12_, "access-point-removed", (GCallback) _network_wifi_interface_access_point_removed_cb_nm_device_wifi_access_point_removed, self, 0);
	_tmp13_ = self->wifi_device;
	g_signal_connect_object ((NMDevice*) _tmp13_, "state-changed", (GCallback) _network_widget_nm_interface_update_nm_device_state_changed, (NetworkWidgetNMInterface*) self, 0);
	_tmp14_ = self->wifi_device;
	_tmp15_ = nm_device_wifi_get_access_points (_tmp14_);
	_tmp16_ = _g_ptr_array_ref0 (_tmp15_);
	aps = _tmp16_;
	_tmp18_ = aps;
	if (_tmp18_ != NULL) {
		GPtrArray* _tmp19_;
		gint _tmp20_;
		gint _tmp21_;
		_tmp19_ = aps;
		_tmp20_ = vala_g_ptr_array_get_length (_tmp19_);
		_tmp21_ = _tmp20_;
		_tmp17_ = _tmp21_ > 0;
	} else {
		_tmp17_ = FALSE;
	}
	if (_tmp17_) {
		GPtrArray* _tmp22_;
		_tmp22_ = aps;
		g_ptr_array_foreach (_tmp22_, _network_wifi_interface_access_point_added_cb_gfunc, self);
	}
	network_widget_nm_interface_update ((NetworkWidgetNMInterface*) self);
	_tmp23_ = self->priv->wifi_item;
	_tmp24_ = network_widget_nm_interface_get_display_title ((NetworkWidgetNMInterface*) self);
	_tmp25_ = _tmp24_;
	granite_switch_model_button_set_text (_tmp23_, _tmp25_);
	g_signal_connect_object ((GObject*) self, "notify::display-title", (GCallback) ___lambda13__g_object_notify, self, 0);
	_tmp26_ = self->priv->wifi_item;
	g_signal_connect_data ((GObject*) _tmp26_, "notify::active", (GCallback) ___lambda14__g_object_notify, block5_data_ref (_data5_), (GClosureNotify) block5_data_unref, 0);
	_g_ptr_array_unref0 (aps);
	block5_data_unref (_data5_);
	_data5_ = NULL;
	return self;
}

NetworkWifiInterface*
network_wifi_interface_new (NMClient* nm_client,
                            NMDevice* _device)
{
	return network_wifi_interface_construct (NETWORK_TYPE_WIFI_INTERFACE, nm_client, _device);
}

static void
network_wifi_interface_real_update_name (NetworkWidgetNMInterface* base,
                                         gint count)
{
	NetworkWifiInterface * self;
	self = (NetworkWifiInterface*) base;
	if (count <= 1) {
		network_widget_nm_interface_set_display_title ((NetworkWidgetNMInterface*) self, _ ("Wireless"));
	} else {
		NMDevice* _tmp0_;
		const gchar* _tmp1_;
		_tmp0_ = ((NetworkWidgetNMInterface*) self)->device;
		_tmp1_ = nm_device_get_description (_tmp0_);
		network_widget_nm_interface_set_display_title ((NetworkWidgetNMInterface*) self, _tmp1_);
	}
}

static gpointer
_rf_kill_device_ref0 (gpointer self)
{
	return self ? rf_kill_device_ref (self) : NULL;
}

static void
_rf_kill_device_unref0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (rf_kill_device_unref (var), NULL));
}

static inline void
_g_list_free__rf_kill_device_unref0_ (GList* self)
{
	g_list_free_full (self, (GDestroyNotify) _rf_kill_device_unref0_);
}

static void
network_wifi_interface_real_update (NetworkWidgetNMInterface* base)
{
	NetworkWifiInterface * self;
	NMDeviceWifi* _tmp0_;
	NMDeviceState _tmp1_;
	NMDeviceState _tmp2_;
	NetworkState _tmp9_;
	NetworkState _tmp10_;
	GEnumValue* _tmp11_;
	RFKillManager* _tmp12_;
	GList* _tmp13_;
	gboolean _tmp24_ = FALSE;
	GraniteSwitchModelButton* _tmp25_;
	GraniteSwitchModelButton* _tmp26_;
	NMDeviceWifi* _tmp27_;
	NMAccessPoint* _tmp28_;
	NMAccessPoint* _tmp29_;
	gboolean _tmp30_ = FALSE;
	NMDeviceWifi* _tmp31_;
	NMDeviceState _tmp32_;
	NMDeviceState _tmp33_;
	self = (NetworkWifiInterface*) base;
	_tmp0_ = self->wifi_device;
	_tmp1_ = nm_device_get_state ((NMDevice*) _tmp0_);
	_tmp2_ = _tmp1_;
	switch (_tmp2_) {
		case NM_DEVICE_STATE_UNKNOWN:
		case NM_DEVICE_STATE_UNMANAGED:
		case NM_DEVICE_STATE_FAILED:
		{
			NetworkWifiMenuItem* _tmp3_;
			network_widget_nm_interface_set_state ((NetworkWidgetNMInterface*) self, NETWORK_STATE_FAILED_WIFI);
			_tmp3_ = self->priv->active_wifi_item;
			if (_tmp3_ != NULL) {
				NetworkWifiMenuItem* _tmp4_;
				NetworkState _tmp5_;
				NetworkState _tmp6_;
				_tmp4_ = self->priv->active_wifi_item;
				_tmp5_ = network_widget_nm_interface_get_state ((NetworkWidgetNMInterface*) self);
				_tmp6_ = _tmp5_;
				network_wifi_menu_item_set_state (_tmp4_, _tmp6_);
			}
			network_wifi_interface_cancel_scan (self);
			break;
		}
		case NM_DEVICE_STATE_DEACTIVATING:
		case NM_DEVICE_STATE_UNAVAILABLE:
		{
			network_wifi_interface_cancel_scan (self);
			network_widget_nm_interface_set_state ((NetworkWidgetNMInterface*) self, NETWORK_STATE_DISCONNECTED);
			break;
		}
		case NM_DEVICE_STATE_DISCONNECTED:
		{
			network_wifi_interface_set_scan_placeholder (self);
			network_widget_nm_interface_set_state ((NetworkWidgetNMInterface*) self, NETWORK_STATE_DISCONNECTED);
			break;
		}
		case NM_DEVICE_STATE_PREPARE:
		case NM_DEVICE_STATE_CONFIG:
		case NM_DEVICE_STATE_NEED_AUTH:
		case NM_DEVICE_STATE_IP_CONFIG:
		case NM_DEVICE_STATE_IP_CHECK:
		case NM_DEVICE_STATE_SECONDARIES:
		{
			network_wifi_interface_set_scan_placeholder (self);
			network_widget_nm_interface_set_state ((NetworkWidgetNMInterface*) self, NETWORK_STATE_CONNECTING_WIFI);
			break;
		}
		case NM_DEVICE_STATE_ACTIVATED:
		{
			NMAccessPoint* _tmp7_;
			network_wifi_interface_set_scan_placeholder (self);
			_tmp7_ = self->priv->active_ap;
			if (_tmp7_ != NULL) {
				NMAccessPoint* _tmp8_;
				_tmp8_ = self->priv->active_ap;
				network_widget_nm_interface_set_state ((NetworkWidgetNMInterface*) self, network_wifi_interface_strength_to_state (self, nm_access_point_get_strength (_tmp8_)));
			} else {
				network_widget_nm_interface_set_state ((NetworkWidgetNMInterface*) self, NETWORK_STATE_CONNECTED_WIFI_WEAK);
			}
			break;
		}
		default:
		break;
	}
	_tmp9_ = network_widget_nm_interface_get_state ((NetworkWidgetNMInterface*) self);
	_tmp10_ = _tmp9_;
	_tmp11_ = g_enum_get_value (g_type_class_ref (NETWORK_TYPE_STATE), _tmp10_);
	g_debug ("WifiInterface.vala:187: New network state: %s", (_tmp11_ != NULL) ? _tmp11_->value_name : NULL);
	self->priv->software_locked = FALSE;
	self->priv->hardware_locked = FALSE;
	_tmp12_ = self->priv->rfkill;
	_tmp13_ = rf_kill_manager_get_devices (_tmp12_);
	{
		GList* device_collection = NULL;
		GList* device_it = NULL;
		device_collection = _tmp13_;
		for (device_it = device_collection; device_it != NULL; device_it = device_it->next) {
			RFKillDevice* _tmp14_;
			RFKillDevice* device = NULL;
			_tmp14_ = _rf_kill_device_ref0 ((RFKillDevice*) device_it->data);
			device = _tmp14_;
			{
				RFKillDevice* _tmp15_;
				RFKillDeviceType _tmp16_;
				RFKillDeviceType _tmp17_;
				RFKillDevice* _tmp18_;
				gboolean _tmp19_;
				gboolean _tmp20_;
				RFKillDevice* _tmp21_;
				gboolean _tmp22_;
				gboolean _tmp23_;
				_tmp15_ = device;
				_tmp16_ = rf_kill_device_get_device_type (_tmp15_);
				_tmp17_ = _tmp16_;
				if (_tmp17_ != RF_KILL_DEVICE_TYPE_WLAN) {
					_rf_kill_device_unref0 (device);
					continue;
				}
				_tmp18_ = device;
				_tmp19_ = rf_kill_device_get_software_lock (_tmp18_);
				_tmp20_ = _tmp19_;
				if (_tmp20_) {
					self->priv->software_locked = TRUE;
				}
				_tmp21_ = device;
				_tmp22_ = rf_kill_device_get_hardware_lock (_tmp21_);
				_tmp23_ = _tmp22_;
				if (_tmp23_) {
					self->priv->hardware_locked = TRUE;
				}
				_rf_kill_device_unref0 (device);
			}
		}
		(device_collection == NULL) ? NULL : (device_collection = (_g_list_free__rf_kill_device_unref0_ (device_collection), NULL));
	}
	if (self->priv->hardware_locked) {
		_tmp24_ = TRUE;
	} else {
		_tmp24_ = self->priv->software_locked;
	}
	self->priv->locked = _tmp24_;
	network_wifi_interface_update_active_ap (self);
	NETWORK_WIDGET_NM_INTERFACE_CLASS (network_wifi_interface_parent_class)->update (G_TYPE_CHECK_INSTANCE_CAST (self, NETWORK_TYPE_WIDGET_NM_INTERFACE, NetworkWidgetNMInterface));
	_tmp25_ = self->priv->wifi_item;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp25_, !self->priv->hardware_locked);
	_tmp26_ = self->priv->wifi_item;
	gtk_toggle_button_set_active ((GtkToggleButton*) _tmp26_, !self->priv->locked);
	_tmp27_ = self->wifi_device;
	_tmp28_ = nm_device_wifi_get_active_access_point (_tmp27_);
	_tmp29_ = _g_object_ref0 (_tmp28_);
	_g_object_unref0 (self->priv->active_ap);
	self->priv->active_ap = _tmp29_;
	_tmp31_ = self->wifi_device;
	_tmp32_ = nm_device_get_state ((NMDevice*) _tmp31_);
	_tmp33_ = _tmp32_;
	if (_tmp33_ == NM_DEVICE_STATE_UNAVAILABLE) {
		_tmp30_ = TRUE;
	} else {
		NetworkState _tmp34_;
		NetworkState _tmp35_;
		_tmp34_ = network_widget_nm_interface_get_state ((NetworkWidgetNMInterface*) self);
		_tmp35_ = _tmp34_;
		_tmp30_ = _tmp35_ == NETWORK_STATE_FAILED_WIFI;
	}
	if (_tmp30_) {
		GtkRevealer* _tmp36_;
		_tmp36_ = self->priv->revealer;
		gtk_revealer_set_reveal_child (_tmp36_, FALSE);
		network_wifi_interface_set_hidden_sensitivity (self, FALSE);
	} else {
		GtkRevealer* _tmp37_;
		_tmp37_ = self->priv->revealer;
		gtk_revealer_set_reveal_child (_tmp37_, TRUE);
		network_wifi_interface_set_hidden_sensitivity (self, TRUE);
	}
}

static Block6Data*
block6_data_ref (Block6Data* _data6_)
{
	g_atomic_int_inc (&_data6_->_ref_count_);
	return _data6_;
}

static void
block6_data_unref (void * _userdata_)
{
	Block6Data* _data6_;
	_data6_ = (Block6Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data6_->_ref_count_)) {
		NetworkWifiInterface* self;
		self = _data6_->self;
		_g_object_unref0 (_data6_->wifi_dialog);
		_g_object_unref0 (self);
		g_slice_free (Block6Data, _data6_);
	}
}

static void
___lambda9_ (Block6Data* _data6_,
             gint response)
{
	NetworkWifiInterface* self;
	self = _data6_->self;
	if (response == ((gint) GTK_RESPONSE_OK)) {
		NMAWifiDialog* _tmp0_;
		_tmp0_ = _data6_->wifi_dialog;
		network_wifi_interface_connect_to_network (self, _tmp0_, NULL, NULL);
	}
}

static void
____lambda9__gtk_dialog_response (GtkDialog* _sender,
                                  gint response_id,
                                  gpointer self)
{
	___lambda9_ (self, response_id);
}

static void
___lambda11_ (NetworkWifiInterface* self,
              GObject* obj,
              GAsyncResult* res)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (res != NULL);
	{
		NMClient* _tmp0_;
		NMActiveConnection* _tmp1_;
		NMActiveConnection* _tmp2_;
		_tmp0_ = self->priv->_nm_client;
		_tmp1_ = nm_client_add_and_activate_connection_finish (_tmp0_, res, &_inner_error0_);
		_tmp2_ = _tmp1_;
		_g_object_unref0 (_tmp2_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* _error_ = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
		_error_ = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp3_ = _error_;
		_tmp4_ = _tmp3_->message;
		g_warning ("WifiInterface.vala:304: %s", _tmp4_);
		_g_error_free0 (_error_);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

static void
____lambda11__gasync_ready_callback (GObject* source_object,
                                     GAsyncResult* res,
                                     gpointer self)
{
	___lambda11_ ((NetworkWifiInterface*) self, source_object, res);
	g_object_unref (self);
}

static gboolean
__lambda12_ (NetworkWifiInterface* self)
{
	gboolean result;
	network_widget_nm_interface_update ((NetworkWidgetNMInterface*) self);
	result = FALSE;
	return result;
}

static gboolean
___lambda12__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda12_ ((NetworkWifiInterface*) self);
	return result;
}

static void
network_wifi_interface_wifi_activate_cb (NetworkWifiInterface* self,
                                         NetworkWifiMenuItem* i)
{
	NMDevice* _tmp0_;
	NMDeviceWifi* _tmp1_;
	NMAccessPoint* _tmp2_;
	NMAccessPoint* _tmp3_;
	NMAccessPoint* _tmp4_;
	GPtrArray* connections = NULL;
	NMClient* _tmp5_;
	GPtrArray* _tmp6_;
	GPtrArray* _tmp7_;
	GPtrArray* device_connections = NULL;
	NMDeviceWifi* _tmp8_;
	GPtrArray* _tmp9_;
	GPtrArray* _tmp10_;
	GPtrArray* ap_connections = NULL;
	NMAccessPoint* _tmp11_;
	NMAccessPoint* _tmp12_;
	GPtrArray* _tmp13_;
	GPtrArray* _tmp14_;
	NMConnection* valid_connection = NULL;
	NMAccessPoint* _tmp15_;
	NMAccessPoint* _tmp16_;
	GPtrArray* _tmp17_;
	NMConnection* _tmp18_;
	NMConnection* _tmp19_;
	NM80211ApSecurityFlags flags = 0U;
	NMAccessPoint* _tmp26_;
	NMAccessPoint* _tmp27_;
	NMAccessPoint* _tmp28_;
	NMAccessPoint* _tmp29_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (i != NULL);
	_tmp0_ = ((NetworkWidgetNMInterface*) self)->device;
	if (_tmp0_ == NULL) {
		return;
	}
	_tmp1_ = self->wifi_device;
	_tmp2_ = nm_device_wifi_get_active_access_point (_tmp1_);
	_tmp3_ = network_wifi_menu_item_get_ap (i);
	_tmp4_ = _tmp3_;
	if (_tmp2_ == _tmp4_) {
		return;
	}
	_tmp5_ = self->priv->_nm_client;
	_tmp6_ = nm_client_get_connections (_tmp5_);
	_tmp7_ = _g_ptr_array_ref0 (_tmp6_);
	connections = _tmp7_;
	_tmp8_ = self->wifi_device;
	_tmp9_ = connections;
	_tmp10_ = nm_device_filter_connections ((NMDevice*) _tmp8_, _tmp9_);
	device_connections = _tmp10_;
	_tmp11_ = network_wifi_menu_item_get_ap (i);
	_tmp12_ = _tmp11_;
	_tmp13_ = device_connections;
	_tmp14_ = nm_access_point_filter_connections (_tmp12_, _tmp13_);
	ap_connections = _tmp14_;
	_tmp15_ = network_wifi_menu_item_get_ap (i);
	_tmp16_ = _tmp15_;
	_tmp17_ = ap_connections;
	_tmp18_ = network_wifi_interface_get_valid_connection (self, _tmp16_, _tmp17_);
	valid_connection = _tmp18_;
	_tmp19_ = valid_connection;
	if (_tmp19_ != NULL) {
		NMClient* _tmp20_;
		NMConnection* _tmp21_;
		NMDeviceWifi* _tmp22_;
		NMAccessPoint* _tmp23_;
		NMAccessPoint* _tmp24_;
		const gchar* _tmp25_;
		_tmp20_ = self->priv->_nm_client;
		_tmp21_ = valid_connection;
		_tmp22_ = self->wifi_device;
		_tmp23_ = network_wifi_menu_item_get_ap (i);
		_tmp24_ = _tmp23_;
		_tmp25_ = nm_object_get_path ((NMObject*) _tmp24_);
		nm_client_activate_connection_async (_tmp20_, _tmp21_, (NMDevice*) _tmp22_, _tmp25_, NULL, NULL, NULL);
		_g_object_unref0 (valid_connection);
		_g_ptr_array_unref0 (ap_connections);
		_g_ptr_array_unref0 (device_connections);
		_g_ptr_array_unref0 (connections);
		return;
	}
	_tmp26_ = network_wifi_menu_item_get_ap (i);
	_tmp27_ = _tmp26_;
	_tmp28_ = network_wifi_menu_item_get_ap (i);
	_tmp29_ = _tmp28_;
	flags = nm_access_point_get_wpa_flags (_tmp27_) | nm_access_point_get_rsn_flags (_tmp29_);
	if (flags != NM_802_11_AP_SEC_NONE) {
		Block6Data* _data6_;
		NMConnection* connection = NULL;
		NMConnection* _tmp30_;
		NMSettingConnection* s_con = NULL;
		NMSettingConnection* _tmp31_;
		NMSettingConnection* _tmp32_;
		gchar* _tmp33_;
		gchar* _tmp34_;
		NMConnection* _tmp35_;
		NMSettingConnection* _tmp36_;
		NMSetting* _tmp37_;
		NMSettingWireless* s_wifi = NULL;
		NMSettingWireless* _tmp43_;
		NMSettingWireless* _tmp44_;
		NMAccessPoint* _tmp45_;
		NMAccessPoint* _tmp46_;
		GBytes* _tmp47_;
		NMConnection* _tmp48_;
		NMSettingWireless* _tmp49_;
		NMSetting* _tmp50_;
		NMClient* _tmp62_;
		NMConnection* _tmp63_;
		NMDeviceWifi* _tmp64_;
		NMAccessPoint* _tmp65_;
		NMAccessPoint* _tmp66_;
		NMAWifiDialog* _tmp67_ = NULL;
		NMAWifiDialog* _tmp68_;
		GtkWidget* _tmp69_;
		NMAWifiDialog* _tmp70_;
		NMAWifiDialog* _tmp71_;
		NMAWifiDialog* _tmp72_;
		_data6_ = g_slice_new0 (Block6Data);
		_data6_->_ref_count_ = 1;
		_data6_->self = g_object_ref (self);
		_tmp30_ = nm_simple_connection_new ();
		connection = _tmp30_;
		_tmp31_ = (NMSettingConnection*) nm_setting_connection_new ();
		s_con = _tmp31_;
		_tmp32_ = s_con;
		_tmp33_ = nm_utils_uuid_generate ();
		_tmp34_ = _tmp33_;
		g_object_set (_tmp32_, "uuid", _tmp34_, NULL);
		_g_free0 (_tmp34_);
		_tmp35_ = connection;
		_tmp36_ = s_con;
		_tmp37_ = _g_object_ref0 ((NMSetting*) _tmp36_);
		nm_connection_add_setting (_tmp35_, _tmp37_);
		if ((flags & NM_802_11_AP_SEC_KEY_MGMT_SAE) == NM_802_11_AP_SEC_KEY_MGMT_SAE) {
			NMSettingWirelessSecurity* s_wsec = NULL;
			NMSettingWirelessSecurity* _tmp38_;
			NMSettingWirelessSecurity* _tmp39_;
			NMConnection* _tmp40_;
			NMSettingWirelessSecurity* _tmp41_;
			NMSetting* _tmp42_;
			_tmp38_ = (NMSettingWirelessSecurity*) nm_setting_wireless_security_new ();
			s_wsec = _tmp38_;
			_tmp39_ = s_wsec;
			g_object_set (_tmp39_, "key-mgmt", "sae", NULL);
			_tmp40_ = connection;
			_tmp41_ = s_wsec;
			_tmp42_ = _g_object_ref0 ((NMSetting*) _tmp41_);
			nm_connection_add_setting (_tmp40_, _tmp42_);
			_g_object_unref0 (s_wsec);
		}
		_tmp43_ = (NMSettingWireless*) nm_setting_wireless_new ();
		s_wifi = _tmp43_;
		_tmp44_ = s_wifi;
		_tmp45_ = network_wifi_menu_item_get_ap (i);
		_tmp46_ = _tmp45_;
		_tmp47_ = nm_access_point_get_ssid (_tmp46_);
		g_object_set (_tmp44_, "ssid", _tmp47_, NULL);
		_tmp48_ = connection;
		_tmp49_ = s_wifi;
		_tmp50_ = _g_object_ref0 ((NMSetting*) _tmp49_);
		nm_connection_add_setting (_tmp48_, _tmp50_);
		if ((flags & NM_802_11_AP_SEC_KEY_MGMT_802_1X) == NM_802_11_AP_SEC_KEY_MGMT_802_1X) {
			NMSettingWirelessSecurity* s_wsec = NULL;
			NMSettingWirelessSecurity* _tmp51_;
			NMSettingWirelessSecurity* _tmp52_;
			NMConnection* _tmp53_;
			NMSettingWirelessSecurity* _tmp54_;
			NMSetting* _tmp55_;
			NMSetting8021x* s_8021x = NULL;
			NMSetting8021x* _tmp56_;
			NMSetting8021x* _tmp57_;
			NMSetting8021x* _tmp58_;
			NMConnection* _tmp59_;
			NMSetting8021x* _tmp60_;
			NMSetting* _tmp61_;
			_tmp51_ = (NMSettingWirelessSecurity*) nm_setting_wireless_security_new ();
			s_wsec = _tmp51_;
			_tmp52_ = s_wsec;
			g_object_set (_tmp52_, "key-mgmt", "wpa-eap", NULL);
			_tmp53_ = connection;
			_tmp54_ = s_wsec;
			_tmp55_ = _g_object_ref0 ((NMSetting*) _tmp54_);
			nm_connection_add_setting (_tmp53_, _tmp55_);
			_tmp56_ = (NMSetting8021x*) nm_setting_802_1x_new ();
			s_8021x = _tmp56_;
			_tmp57_ = s_8021x;
			nm_setting_802_1x_add_eap_method (_tmp57_, "ttls");
			_tmp58_ = s_8021x;
			g_object_set (_tmp58_, "phase2-auth", "mschapv2", NULL);
			_tmp59_ = connection;
			_tmp60_ = s_8021x;
			_tmp61_ = _g_object_ref0 ((NMSetting*) _tmp60_);
			nm_connection_add_setting (_tmp59_, _tmp61_);
			_g_object_unref0 (s_8021x);
			_g_object_unref0 (s_wsec);
		}
		_tmp62_ = self->priv->_nm_client;
		_tmp63_ = connection;
		_tmp64_ = self->wifi_device;
		_tmp65_ = network_wifi_menu_item_get_ap (i);
		_tmp66_ = _tmp65_;
		_tmp67_ = (NMAWifiDialog*) nma_wifi_dialog_new (_tmp62_, _tmp63_, (NMDevice*) _tmp64_, _tmp66_, FALSE);
		gtk_window_set_deletable ((GtkWindow*) _tmp67_, FALSE);
		g_object_ref_sink (_tmp67_);
		_data6_->wifi_dialog = _tmp67_;
		_tmp68_ = _data6_->wifi_dialog;
		_tmp69_ = gtk_widget_get_toplevel ((GtkWidget*) self);
		gtk_window_set_transient_for ((GtkWindow*) _tmp68_, G_TYPE_CHECK_INSTANCE_CAST (_tmp69_, gtk_window_get_type (), GtkWindow));
		_tmp70_ = _data6_->wifi_dialog;
		g_signal_connect_data ((GtkDialog*) _tmp70_, "response", (GCallback) ____lambda9__gtk_dialog_response, block6_data_ref (_data6_), (GClosureNotify) block6_data_unref, 0);
		_tmp71_ = _data6_->wifi_dialog;
		gtk_dialog_run ((GtkDialog*) _tmp71_);
		_tmp72_ = _data6_->wifi_dialog;
		gtk_widget_destroy ((GtkWidget*) _tmp72_);
		_g_object_unref0 (s_wifi);
		_g_object_unref0 (s_con);
		_g_object_unref0 (connection);
		block6_data_unref (_data6_);
		_data6_ = NULL;
	} else {
		NMClient* _tmp73_;
		NMConnection* _tmp74_;
		NMConnection* _tmp75_;
		NMDeviceWifi* _tmp76_;
		NMAccessPoint* _tmp77_;
		NMAccessPoint* _tmp78_;
		const gchar* _tmp79_;
		_tmp73_ = self->priv->_nm_client;
		_tmp74_ = nm_simple_connection_new ();
		_tmp75_ = _tmp74_;
		_tmp76_ = self->wifi_device;
		_tmp77_ = network_wifi_menu_item_get_ap (i);
		_tmp78_ = _tmp77_;
		_tmp79_ = nm_object_get_path ((NMObject*) _tmp78_);
		nm_client_add_and_activate_connection_async (_tmp73_, _tmp75_, (NMDevice*) _tmp76_, _tmp79_, NULL, ____lambda11__gasync_ready_callback, g_object_ref (self));
		_g_object_unref0 (_tmp75_);
	}
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda12__gsource_func, g_object_ref (self), g_object_unref);
	_g_object_unref0 (valid_connection);
	_g_ptr_array_unref0 (ap_connections);
	_g_ptr_array_unref0 (device_connections);
	_g_ptr_array_unref0 (connections);
}

void
network_wifi_interface_start_scanning (NetworkWifiInterface* self)
{
	GCancellable* _tmp0_;
	NMDeviceWifi* _tmp1_;
	GCancellable* _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->wifi_scan_cancellable;
	g_cancellable_reset (_tmp0_);
	_tmp1_ = self->wifi_device;
	_tmp2_ = self->priv->wifi_scan_cancellable;
	nm_device_wifi_request_scan_async (_tmp1_, _tmp2_, NULL, NULL);
}

void
network_wifi_interface_cancel_scanning (NetworkWifiInterface* self)
{
	GCancellable* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->wifi_scan_cancellable;
	g_cancellable_cancel (_tmp0_);
}

static NMConnection*
network_wifi_interface_get_valid_connection (NetworkWifiInterface* self,
                                             NMAccessPoint* ap,
                                             GPtrArray* ap_connections)
{
	NMConnection* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (ap != NULL, NULL);
	g_return_val_if_fail (ap_connections != NULL, NULL);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				gint _tmp2_;
				gint _tmp3_;
				NMConnection* connection = NULL;
				gconstpointer _tmp4_;
				NMConnection* _tmp5_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = vala_g_ptr_array_get_length (ap_connections);
				_tmp3_ = _tmp2_;
				if (!(i < _tmp3_)) {
					break;
				}
				_tmp4_ = g_ptr_array_index (ap_connections, (guint) i);
				connection = (NMConnection*) _tmp4_;
				_tmp5_ = connection;
				if (nm_access_point_connection_valid (ap, _tmp5_)) {
					NMConnection* _tmp6_;
					NMConnection* _tmp7_;
					_tmp6_ = connection;
					_tmp7_ = _g_object_ref0 (_tmp6_);
					result = _tmp7_;
					return result;
				}
			}
		}
	}
	result = NULL;
	return result;
}

static Block7Data*
block7_data_ref (Block7Data* _data7_)
{
	g_atomic_int_inc (&_data7_->_ref_count_);
	return _data7_;
}

static void
block7_data_unref (void * _userdata_)
{
	Block7Data* _data7_;
	_data7_ = (Block7Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data7_->_ref_count_)) {
		NetworkWifiInterface* self;
		self = _data7_->self;
		_g_object_unref0 (_data7_->hidden_dialog);
		_g_object_unref0 (self);
		g_slice_free (Block7Data, _data7_);
	}
}

static void
__lambda15_ (Block7Data* _data7_,
             gint response)
{
	NetworkWifiInterface* self;
	self = _data7_->self;
	if (response == ((gint) GTK_RESPONSE_OK)) {
		network_wifi_interface_connect_to_network (self, _data7_->hidden_dialog, NULL, NULL);
	}
}

static void
___lambda15__gtk_dialog_response (GtkDialog* _sender,
                                  gint response_id,
                                  gpointer self)
{
	__lambda15_ (self, response_id);
}

void
network_wifi_interface_connect_to_hidden (NetworkWifiInterface* self)
{
	Block7Data* _data7_;
	NMClient* _tmp0_;
	NMAWifiDialog* _tmp1_ = NULL;
	GtkWidget* _tmp2_;
	g_return_if_fail (self != NULL);
	_data7_ = g_slice_new0 (Block7Data);
	_data7_->_ref_count_ = 1;
	_data7_->self = g_object_ref (self);
	_tmp0_ = self->priv->_nm_client;
	_tmp1_ = (NMAWifiDialog*) nma_wifi_dialog_new_for_other (_tmp0_);
	gtk_window_set_deletable ((GtkWindow*) _tmp1_, FALSE);
	g_object_ref_sink (_tmp1_);
	_data7_->hidden_dialog = _tmp1_;
	_tmp2_ = gtk_widget_get_toplevel ((GtkWidget*) self);
	gtk_window_set_transient_for ((GtkWindow*) _data7_->hidden_dialog, G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, gtk_window_get_type (), GtkWindow));
	g_signal_connect_data ((GtkDialog*) _data7_->hidden_dialog, "response", (GCallback) ___lambda15__gtk_dialog_response, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
	gtk_dialog_run ((GtkDialog*) _data7_->hidden_dialog);
	gtk_widget_destroy ((GtkWidget*) _data7_->hidden_dialog);
	block7_data_unref (_data7_);
	_data7_ = NULL;
}

static void
network_wifi_interface_connect_to_network_data_free (gpointer _data)
{
	NetworkWifiInterfaceConnectToNetworkData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->wifi_dialog);
	_g_object_unref0 (_data_->self);
	g_slice_free (NetworkWifiInterfaceConnectToNetworkData, _data_);
}

static void
network_wifi_interface_connect_to_network (NetworkWifiInterface* self,
                                           NMAWifiDialog* wifi_dialog,
                                           GAsyncReadyCallback _callback_,
                                           gpointer _user_data_)
{
	NetworkWifiInterfaceConnectToNetworkData* _data_;
	NetworkWifiInterface* _tmp0_;
	NMAWifiDialog* _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (wifi_dialog != NULL);
	_data_ = g_slice_new0 (NetworkWifiInterfaceConnectToNetworkData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, network_wifi_interface_connect_to_network_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_tmp1_ = _g_object_ref0 (wifi_dialog);
	_g_object_unref0 (_data_->wifi_dialog);
	_data_->wifi_dialog = _tmp1_;
	network_wifi_interface_connect_to_network_co (_data_);
}

static void
network_wifi_interface_connect_to_network_finish (NetworkWifiInterface* self,
                                                  GAsyncResult* _res_)
{
	NetworkWifiInterfaceConnectToNetworkData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
}

static Block8Data*
block8_data_ref (Block8Data* _data8_)
{
	g_atomic_int_inc (&_data8_->_ref_count_);
	return _data8_;
}

static void
block8_data_unref (void * _userdata_)
{
	Block8Data* _data8_;
	_data8_ = (Block8Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data8_->_ref_count_)) {
		NetworkWifiInterface* self;
		self = _data8_->self;
		_g_object_unref0 (_data8_->dialog_connection);
		_g_object_unref0 (_data8_->fuzzy);
		_g_object_unref0 (self);
		g_slice_free (Block8Data, _data8_);
	}
}

static void
__lambda10_ (Block8Data* _data8_,
             NMRemoteConnection* possible)
{
	NetworkWifiInterface* self;
	NMConnection* _tmp0_;
	self = _data8_->self;
	g_return_if_fail (possible != NULL);
	_tmp0_ = _data8_->dialog_connection;
	if (nm_connection_compare (_tmp0_, (NMConnection*) possible, NM_SETTING_COMPARE_FLAG_FUZZY | NM_SETTING_COMPARE_FLAG_IGNORE_ID)) {
		NMConnection* _tmp1_;
		_tmp1_ = _g_object_ref0 ((NMConnection*) possible);
		_g_object_unref0 (_data8_->fuzzy);
		_data8_->fuzzy = _tmp1_;
	}
}

static void
___lambda10__gfunc (gconstpointer data,
                    gpointer self)
{
	__lambda10_ (self, (NMRemoteConnection*) data);
}

static void
network_wifi_interface_connect_to_network_ready (GObject* source_object,
                                                 GAsyncResult* _res_,
                                                 gpointer _user_data_)
{
	NetworkWifiInterfaceConnectToNetworkData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	network_wifi_interface_connect_to_network_co (_data_);
}

static gboolean
network_wifi_interface_connect_to_network_co (NetworkWifiInterfaceConnectToNetworkData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		case 2:
		goto _state_2;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_data8_ = g_slice_new0 (Block8Data);
	_data_->_data8_->_ref_count_ = 1;
	_data_->_data8_->self = g_object_ref (_data_->self);
	_data_->_data8_->_async_data_ = _data_;
	_data_->_data8_->fuzzy = NULL;
	_data_->dialog_ap = NULL;
	_data_->_tmp0_ = NULL;
	_data_->_tmp1_ = NULL;
	_data_->_tmp2_ = nma_wifi_dialog_get_connection (_data_->wifi_dialog, &_data_->_tmp0_, &_data_->_tmp1_);
	_g_object_unref0 (_data_->dialog_device);
	_data_->dialog_device = _data_->_tmp0_;
	_g_object_unref0 (_data_->dialog_ap);
	_data_->dialog_ap = _data_->_tmp1_;
	_data_->_data8_->dialog_connection = _data_->_tmp2_;
	_data_->_tmp3_ = _data_->self->priv->_nm_client;
	_data_->_tmp4_ = nm_client_get_connections (_data_->_tmp3_);
	g_ptr_array_foreach (_data_->_tmp4_, ___lambda10__gfunc, _data_->_data8_);
	_data_->path = NULL;
	_data_->_tmp5_ = _data_->dialog_ap;
	if (_data_->_tmp5_ != NULL) {
		_data_->_tmp6_ = _data_->dialog_ap;
		_data_->_tmp7_ = nm_object_get_path ((NMObject*) _data_->_tmp6_);
		_data_->_tmp8_ = g_strdup (_data_->_tmp7_);
		_g_free0 (_data_->path);
		_data_->path = _data_->_tmp8_;
	}
	_data_->_tmp9_ = _data_->_data8_->fuzzy;
	if (_data_->_tmp9_ != NULL) {
		{
			_data_->_tmp10_ = _data_->self->priv->_nm_client;
			_data_->_tmp11_ = _data_->_data8_->fuzzy;
			_data_->_tmp12_ = _data_->self->wifi_device;
			_data_->_tmp13_ = _data_->path;
			_data_->_state_ = 1;
			nm_client_activate_connection_async (_data_->_tmp10_, _data_->_tmp11_, (NMDevice*) _data_->_tmp12_, _data_->_tmp13_, NULL, network_wifi_interface_connect_to_network_ready, _data_);
			return FALSE;
			_state_1:
			_data_->_tmp14_ = nm_client_activate_connection_finish (_data_->_tmp10_, _data_->_res_, &_data_->_inner_error0_);
			_data_->_tmp15_ = _data_->_tmp14_;
			_g_object_unref0 (_data_->_tmp15_);
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
				goto __catch0_g_error;
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
			_data_->_error_ = _data_->_inner_error0_;
			_data_->_inner_error0_ = NULL;
			_data_->_tmp16_ = _data_->_error_;
			_data_->_tmp17_ = _data_->_tmp16_->message;
			g_critical ("WifiInterface.vala:373: %s", _data_->_tmp17_);
			_g_error_free0 (_data_->_error_);
		}
		__finally0:
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			_g_free0 (_data_->path);
			_g_object_unref0 (_data_->dialog_ap);
			_g_object_unref0 (_data_->dialog_device);
			block8_data_unref (_data_->_data8_);
			_data_->_data8_ = NULL;
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
			g_clear_error (&_data_->_inner_error0_);
			g_object_unref (_data_->_async_result);
			return FALSE;
		}
	} else {
		_data_->mode = NULL;
		_data_->_tmp18_ = _data_->_data8_->dialog_connection;
		_data_->_tmp19_ = nm_connection_get_setting_wireless (_data_->_tmp18_);
		_data_->setting_wireless = _data_->_tmp19_;
		_data_->_tmp20_ = _data_->setting_wireless;
		if (_data_->_tmp20_ != NULL) {
			_data_->_tmp21_ = _data_->setting_wireless;
			_data_->_tmp22_ = nm_setting_wireless_get_mode (_data_->_tmp21_);
			_data_->_tmp23_ = g_strdup (_data_->_tmp22_);
			_g_free0 (_data_->mode);
			_data_->mode = _data_->_tmp23_;
		}
		_data_->_tmp24_ = _data_->mode;
		if (g_strcmp0 (_data_->_tmp24_, "adhoc") == 0) {
			_data_->_tmp25_ = _data_->_data8_->dialog_connection;
			_data_->_tmp26_ = nm_connection_get_setting_connection (_data_->_tmp25_);
			_data_->_tmp27_ = _g_object_ref0 (_data_->_tmp26_);
			_data_->connection_setting = _data_->_tmp27_;
			_data_->_tmp28_ = _data_->connection_setting;
			if (_data_->_tmp28_ == NULL) {
				_data_->_tmp29_ = (NMSettingConnection*) nm_setting_connection_new ();
				_g_object_unref0 (_data_->connection_setting);
				_data_->connection_setting = _data_->_tmp29_;
			}
			_data_->_tmp30_ = _data_->_data8_->dialog_connection;
			_data_->_tmp31_ = _data_->connection_setting;
			_data_->_tmp32_ = _g_object_ref0 ((NMSetting*) _data_->_tmp31_);
			nm_connection_add_setting (_data_->_tmp30_, _data_->_tmp32_);
			_g_object_unref0 (_data_->connection_setting);
		}
		{
			_data_->_tmp33_ = _data_->self->priv->_nm_client;
			_data_->_tmp34_ = _data_->_data8_->dialog_connection;
			_data_->_tmp35_ = _data_->dialog_device;
			_data_->_tmp36_ = _data_->path;
			_data_->_state_ = 2;
			nm_client_add_and_activate_connection_async (_data_->_tmp33_, _data_->_tmp34_, _data_->_tmp35_, _data_->_tmp36_, NULL, network_wifi_interface_connect_to_network_ready, _data_);
			return FALSE;
			_state_2:
			_data_->_tmp37_ = nm_client_add_and_activate_connection_finish (_data_->_tmp33_, _data_->_res_, &_data_->_inner_error0_);
			_data_->_tmp38_ = _data_->_tmp37_;
			_g_object_unref0 (_data_->_tmp38_);
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
				goto __catch1_g_error;
			}
		}
		goto __finally1;
		__catch1_g_error:
		{
			_data_->_vala1__error_ = _data_->_inner_error0_;
			_data_->_inner_error0_ = NULL;
			_data_->_tmp39_ = _data_->_vala1__error_;
			_data_->_tmp40_ = _data_->_tmp39_->message;
			g_critical ("WifiInterface.vala:394: %s", _data_->_tmp40_);
			_g_error_free0 (_data_->_vala1__error_);
		}
		__finally1:
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			_g_free0 (_data_->mode);
			_g_free0 (_data_->path);
			_g_object_unref0 (_data_->dialog_ap);
			_g_object_unref0 (_data_->dialog_device);
			block8_data_unref (_data_->_data8_);
			_data_->_data8_ = NULL;
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
			g_clear_error (&_data_->_inner_error0_);
			g_object_unref (_data_->_async_result);
			return FALSE;
		}
		_g_free0 (_data_->mode);
	}
	_g_free0 (_data_->path);
	_g_object_unref0 (_data_->dialog_ap);
	_g_object_unref0 (_data_->dialog_device);
	block8_data_unref (_data_->_data8_);
	_data_->_data8_ = NULL;
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

static gpointer
_g_bytes_ref0 (gpointer self)
{
	return self ? g_bytes_ref (self) : NULL;
}

static void
_network_wifi_interface_wifi_activate_cb_network_wifi_menu_item_user_action (NetworkWifiMenuItem* _sender,
                                                                             gpointer self)
{
	network_wifi_interface_wifi_activate_cb ((NetworkWifiInterface*) self, _sender);
}

static void
network_wifi_interface_access_point_added_cb (NetworkWifiInterface* self,
                                              GObject* ap_)
{
	NMAccessPoint* ap = NULL;
	NMAccessPoint* _tmp0_;
	NetworkWifiMenuItem* previous_wifi_item = NULL;
	NetworkWifiMenuItem* _tmp1_;
	NetworkWifiMenuItem* _tmp2_;
	GBytes* ap_ssid = NULL;
	NMAccessPoint* _tmp3_;
	GBytes* _tmp4_;
	GBytes* _tmp5_;
	gboolean found = FALSE;
	GtkListBox* _tmp6_;
	GList* _tmp7_;
	gboolean _tmp28_ = FALSE;
	g_return_if_fail (self != NULL);
	g_return_if_fail (ap_ != NULL);
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (ap_, nm_access_point_get_type (), NMAccessPoint));
	ap = _tmp0_;
	_tmp1_ = self->priv->blank_item;
	_tmp2_ = _g_object_ref0 (_tmp1_);
	previous_wifi_item = _tmp2_;
	_tmp3_ = ap;
	_tmp4_ = nm_access_point_get_ssid (_tmp3_);
	_tmp5_ = _tmp4_;
	ap_ssid = _tmp5_;
	found = FALSE;
	_tmp6_ = self->priv->wifi_list;
	_tmp7_ = gtk_container_get_children ((GtkContainer*) _tmp6_);
	{
		GList* w_collection = NULL;
		GList* w_it = NULL;
		w_collection = _tmp7_;
		for (w_it = w_collection; w_it != NULL; w_it = w_it->next) {
			GtkWidget* w = NULL;
			w = (GtkWidget*) w_it->data;
			{
				NetworkWifiMenuItem* menu_item = NULL;
				GtkWidget* _tmp8_;
				NetworkWifiMenuItem* _tmp9_;
				GBytes* menu_ssid = NULL;
				NetworkWifiMenuItem* _tmp10_;
				GBytes* _tmp11_;
				GBytes* _tmp12_;
				GBytes* _tmp13_;
				gboolean _tmp14_ = FALSE;
				gboolean _tmp15_ = FALSE;
				GBytes* _tmp16_;
				NetworkWifiMenuItem* _tmp26_;
				NetworkWifiMenuItem* _tmp27_;
				_tmp8_ = w;
				_tmp9_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, NETWORK_TYPE_WIFI_MENU_ITEM, NetworkWifiMenuItem));
				menu_item = _tmp9_;
				_tmp10_ = menu_item;
				_tmp11_ = network_wifi_menu_item_get_ssid (_tmp10_);
				_tmp12_ = _tmp11_;
				_tmp13_ = _g_bytes_ref0 (_tmp12_);
				menu_ssid = _tmp13_;
				_tmp16_ = menu_ssid;
				if (_tmp16_ != NULL) {
					NMAccessPoint* _tmp17_;
					GBytes* _tmp18_;
					GBytes* _tmp19_;
					_tmp17_ = ap;
					_tmp18_ = nm_access_point_get_ssid (_tmp17_);
					_tmp19_ = _tmp18_;
					_tmp15_ = _tmp19_ != NULL;
				} else {
					_tmp15_ = FALSE;
				}
				if (_tmp15_) {
					NMAccessPoint* _tmp20_;
					GBytes* _tmp21_;
					GBytes* _tmp22_;
					GBytes* _tmp23_;
					_tmp20_ = ap;
					_tmp21_ = nm_access_point_get_ssid (_tmp20_);
					_tmp22_ = _tmp21_;
					_tmp23_ = menu_ssid;
					_tmp14_ = g_bytes_compare (_tmp22_, _tmp23_) == 0;
				} else {
					_tmp14_ = FALSE;
				}
				if (_tmp14_) {
					NetworkWifiMenuItem* _tmp24_;
					NMAccessPoint* _tmp25_;
					found = TRUE;
					_tmp24_ = menu_item;
					_tmp25_ = ap;
					network_wifi_menu_item_add_ap (_tmp24_, _tmp25_);
					_g_bytes_unref0 (menu_ssid);
					_g_object_unref0 (menu_item);
					break;
				}
				_tmp26_ = menu_item;
				_tmp27_ = _g_object_ref0 (_tmp26_);
				_g_object_unref0 (previous_wifi_item);
				previous_wifi_item = _tmp27_;
				_g_bytes_unref0 (menu_ssid);
				_g_object_unref0 (menu_item);
			}
		}
		(w_collection == NULL) ? NULL : (w_collection = (g_list_free (w_collection), NULL));
	}
	if (!found) {
		GBytes* _tmp29_;
		_tmp29_ = ap_ssid;
		_tmp28_ = _tmp29_ != NULL;
	} else {
		_tmp28_ = FALSE;
	}
	if (_tmp28_) {
		NetworkWifiMenuItem* item = NULL;
		NMAccessPoint* _tmp30_;
		NetworkWifiMenuItem* _tmp31_;
		NetworkWifiMenuItem* _tmp32_;
		NetworkWifiMenuItem* _tmp33_;
		NetworkWifiMenuItem* _tmp34_;
		NetworkWifiMenuItem* _tmp35_;
		NetworkWifiMenuItem* _tmp36_;
		GtkListBox* _tmp37_;
		NetworkWifiMenuItem* _tmp38_;
		GtkListBox* _tmp39_;
		_tmp30_ = ap;
		_tmp31_ = previous_wifi_item;
		_tmp32_ = network_wifi_menu_item_new (_tmp30_, _tmp31_);
		g_object_ref_sink (_tmp32_);
		item = _tmp32_;
		_tmp33_ = item;
		_tmp34_ = _g_object_ref0 (_tmp33_);
		_g_object_unref0 (previous_wifi_item);
		previous_wifi_item = _tmp34_;
		_tmp35_ = item;
		gtk_widget_set_visible ((GtkWidget*) _tmp35_, TRUE);
		_tmp36_ = item;
		g_signal_connect_object (_tmp36_, "user-action", (GCallback) _network_wifi_interface_wifi_activate_cb_network_wifi_menu_item_user_action, self, 0);
		_tmp37_ = self->priv->wifi_list;
		_tmp38_ = item;
		gtk_container_add ((GtkContainer*) _tmp37_, (GtkWidget*) _tmp38_);
		_tmp39_ = self->priv->wifi_list;
		gtk_widget_show_all ((GtkWidget*) _tmp39_);
		network_widget_nm_interface_update ((NetworkWidgetNMInterface*) self);
		_g_object_unref0 (item);
	}
	_g_object_unref0 (previous_wifi_item);
	_g_object_unref0 (ap);
}

static void
network_wifi_interface_update_active_ap (NetworkWifiInterface* self)
{
	NMDeviceWifi* _tmp0_;
	NMAccessPoint* _tmp1_;
	NMAccessPoint* _tmp2_;
	NetworkWifiMenuItem* _tmp3_;
	NMAccessPoint* _tmp8_;
	g_return_if_fail (self != NULL);
	g_debug ("WifiInterface.vala:451: Update active AP");
	_tmp0_ = self->wifi_device;
	_tmp1_ = nm_device_wifi_get_active_access_point (_tmp0_);
	_tmp2_ = _g_object_ref0 (_tmp1_);
	_g_object_unref0 (self->priv->active_ap);
	self->priv->active_ap = _tmp2_;
	_tmp3_ = self->priv->active_wifi_item;
	if (_tmp3_ != NULL) {
		NetworkWifiMenuItem* _tmp4_;
		NetworkState _tmp5_;
		NetworkState _tmp6_;
		_tmp4_ = self->priv->active_wifi_item;
		_tmp5_ = network_wifi_menu_item_get_state (_tmp4_);
		_tmp6_ = _tmp5_;
		if (_tmp6_ == NETWORK_STATE_CONNECTING_WIFI) {
			NetworkWifiMenuItem* _tmp7_;
			_tmp7_ = self->priv->active_wifi_item;
			network_wifi_menu_item_set_state (_tmp7_, NETWORK_STATE_DISCONNECTED);
		}
		_g_object_unref0 (self->priv->active_wifi_item);
		self->priv->active_wifi_item = NULL;
	}
	_tmp8_ = self->priv->active_ap;
	if (_tmp8_ == NULL) {
		NetworkWifiMenuItem* _tmp9_;
		g_debug ("WifiInterface.vala:463: No active AP");
		_tmp9_ = self->priv->blank_item;
		network_wifi_menu_item_set_active (_tmp9_, TRUE);
	} else {
		GBytes* active_ap_ssid = NULL;
		NMAccessPoint* _tmp10_;
		GBytes* _tmp11_;
		GBytes* _tmp12_;
		GBytes* _tmp13_;
		gsize _tmp14_ = 0;
		guint8* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
		const gchar* _tmp18_;
		gboolean found = FALSE;
		GtkListBox* _tmp19_;
		GList* _tmp20_;
		_tmp10_ = self->priv->active_ap;
		_tmp11_ = nm_access_point_get_ssid (_tmp10_);
		_tmp12_ = _tmp11_;
		active_ap_ssid = _tmp12_;
		_tmp13_ = active_ap_ssid;
		_tmp15_ = g_bytes_get_data (_tmp13_, &_tmp14_);
		_tmp16_ = nm_utils_ssid_to_utf8 (_tmp15_, (gsize) _tmp14_);
		_tmp17_ = _tmp16_;
		network_wifi_interface_set_active_ap_name (self, _tmp17_);
		_g_free0 (_tmp17_);
		_tmp18_ = self->priv->_active_ap_name;
		g_debug ("WifiInterface.vala:468: Active ap: %s", _tmp18_);
		found = FALSE;
		_tmp19_ = self->priv->wifi_list;
		_tmp20_ = gtk_container_get_children ((GtkContainer*) _tmp19_);
		{
			GList* w_collection = NULL;
			GList* w_it = NULL;
			w_collection = _tmp20_;
			for (w_it = w_collection; w_it != NULL; w_it = w_it->next) {
				GtkWidget* w = NULL;
				w = (GtkWidget*) w_it->data;
				{
					NetworkWifiMenuItem* menu_item = NULL;
					GtkWidget* _tmp21_;
					NetworkWifiMenuItem* _tmp22_;
					GBytes* _tmp23_;
					NetworkWifiMenuItem* _tmp24_;
					GBytes* _tmp25_;
					GBytes* _tmp26_;
					_tmp21_ = w;
					_tmp22_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, NETWORK_TYPE_WIFI_MENU_ITEM, NetworkWifiMenuItem));
					menu_item = _tmp22_;
					_tmp23_ = active_ap_ssid;
					_tmp24_ = menu_item;
					_tmp25_ = network_wifi_menu_item_get_ssid (_tmp24_);
					_tmp26_ = _tmp25_;
					if (g_bytes_compare (_tmp23_, _tmp26_) == 0) {
						NetworkWifiMenuItem* _tmp27_;
						NetworkWifiMenuItem* _tmp28_;
						NetworkWifiMenuItem* _tmp29_;
						NetworkWifiMenuItem* _tmp30_;
						NetworkState _tmp31_;
						NetworkState _tmp32_;
						found = TRUE;
						_tmp27_ = menu_item;
						network_wifi_menu_item_set_active (_tmp27_, TRUE);
						_tmp28_ = menu_item;
						_tmp29_ = _g_object_ref0 (_tmp28_);
						_g_object_unref0 (self->priv->active_wifi_item);
						self->priv->active_wifi_item = _tmp29_;
						_tmp30_ = self->priv->active_wifi_item;
						_tmp31_ = network_widget_nm_interface_get_state ((NetworkWidgetNMInterface*) self);
						_tmp32_ = _tmp31_;
						network_wifi_menu_item_set_state (_tmp30_, _tmp32_);
					}
					_g_object_unref0 (menu_item);
				}
			}
			(w_collection == NULL) ? NULL : (w_collection = (g_list_free (w_collection), NULL));
		}
		if (!found) {
			g_debug ("WifiInterface.vala:484: Active AP not added");
		}
	}
}

static void
network_wifi_interface_access_point_removed_cb (NetworkWifiInterface* self,
                                                GObject* ap_)
{
	NMAccessPoint* ap = NULL;
	NMAccessPoint* _tmp0_;
	NMAccessPoint* _tmp1_;
	GBytes* _tmp2_;
	GBytes* _tmp3_;
	NetworkWifiMenuItem* found_item = NULL;
	GtkListBox* _tmp4_;
	GList* _tmp5_;
	NetworkWifiMenuItem* _tmp17_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (ap_ != NULL);
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (ap_, nm_access_point_get_type (), NMAccessPoint));
	ap = _tmp0_;
	_tmp1_ = ap;
	_tmp2_ = nm_access_point_get_ssid (_tmp1_);
	_tmp3_ = _tmp2_;
	if (_tmp3_ == NULL) {
		network_widget_nm_interface_update ((NetworkWidgetNMInterface*) self);
		_g_object_unref0 (ap);
		return;
	}
	found_item = NULL;
	_tmp4_ = self->priv->wifi_list;
	_tmp5_ = gtk_container_get_children ((GtkContainer*) _tmp4_);
	{
		GList* w_collection = NULL;
		GList* w_it = NULL;
		w_collection = _tmp5_;
		for (w_it = w_collection; w_it != NULL; w_it = w_it->next) {
			GtkWidget* w = NULL;
			w = (GtkWidget*) w_it->data;
			{
				NetworkWifiMenuItem* menu_item = NULL;
				GtkWidget* _tmp6_;
				NetworkWifiMenuItem* _tmp7_;
				NetworkWifiMenuItem* _tmp8_;
				NMAccessPoint* _tmp9_;
				GBytes* _tmp10_;
				GBytes* _tmp11_;
				NetworkWifiMenuItem* _tmp12_;
				GBytes* _tmp13_;
				GBytes* _tmp14_;
				_tmp6_ = w;
				_tmp7_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, NETWORK_TYPE_WIFI_MENU_ITEM, NetworkWifiMenuItem));
				menu_item = _tmp7_;
				_tmp8_ = menu_item;
				_vala_assert (_tmp8_ != NULL, "menu_item != null");
				_tmp9_ = ap;
				_tmp10_ = nm_access_point_get_ssid (_tmp9_);
				_tmp11_ = _tmp10_;
				_tmp12_ = menu_item;
				_tmp13_ = network_wifi_menu_item_get_ssid (_tmp12_);
				_tmp14_ = _tmp13_;
				if (g_bytes_compare (_tmp11_, _tmp14_) == 0) {
					NetworkWifiMenuItem* _tmp15_;
					NetworkWifiMenuItem* _tmp16_;
					_tmp15_ = menu_item;
					_tmp16_ = _g_object_ref0 (_tmp15_);
					_g_object_unref0 (found_item);
					found_item = _tmp16_;
					_g_object_unref0 (menu_item);
					break;
				}
				_g_object_unref0 (menu_item);
			}
		}
		(w_collection == NULL) ? NULL : (w_collection = (g_list_free (w_collection), NULL));
	}
	_tmp17_ = found_item;
	if (_tmp17_ == NULL) {
		g_critical ("WifiInterface.vala:510: Couldn't remove an access point which has not " \
"been added.");
	} else {
		NetworkWifiMenuItem* _tmp18_;
		NMAccessPoint* _tmp19_;
		_tmp18_ = found_item;
		_tmp19_ = ap;
		if (!network_wifi_menu_item_remove_ap (_tmp18_, _tmp19_)) {
			NetworkWifiMenuItem* _tmp20_;
			_tmp20_ = found_item;
			gtk_widget_destroy ((GtkWidget*) _tmp20_);
		}
	}
	network_widget_nm_interface_update ((NetworkWidgetNMInterface*) self);
	_g_object_unref0 (found_item);
	_g_object_unref0 (ap);
}

static NetworkState
network_wifi_interface_strength_to_state (NetworkWifiInterface* self,
                                          guint8 strength)
{
	NetworkState result;
	g_return_val_if_fail (self != NULL, 0);
	if (((gint) strength) < 30) {
		result = NETWORK_STATE_CONNECTED_WIFI_WEAK;
		return result;
	} else {
		if (((gint) strength) < 55) {
			result = NETWORK_STATE_CONNECTED_WIFI_OK;
			return result;
		} else {
			if (((gint) strength) < 80) {
				result = NETWORK_STATE_CONNECTED_WIFI_GOOD;
				return result;
			} else {
				result = NETWORK_STATE_CONNECTED_WIFI_EXCELLENT;
				return result;
			}
		}
	}
}

static void
network_wifi_interface_cancel_scan (NetworkWifiInterface* self)
{
	g_return_if_fail (self != NULL);
	if (self->priv->timeout_scan > ((guint) 0)) {
		g_source_remove (self->priv->timeout_scan);
		self->priv->timeout_scan = (guint) 0;
	}
}

static gboolean
___lambda8_ (NetworkWifiInterface* self)
{
	GtkStack* _tmp0_;
	gboolean result;
	self->priv->timeout_scan = (guint) 0;
	_tmp0_ = self->priv->placeholder;
	gtk_stack_set_visible_child_name (_tmp0_, "no-aps");
	result = FALSE;
	return result;
}

static gboolean
____lambda8__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda8_ ((NetworkWifiInterface*) self);
	return result;
}

static void
network_wifi_interface_set_scan_placeholder (NetworkWifiInterface* self)
{
	NetworkState _tmp0_;
	NetworkState _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = network_widget_nm_interface_get_state ((NetworkWidgetNMInterface*) self);
	_tmp1_ = _tmp0_;
	if (_tmp1_ == NETWORK_STATE_DISCONNECTED) {
		GtkStack* _tmp2_;
		NMDeviceWifi* _tmp3_;
		_tmp2_ = self->priv->placeholder;
		gtk_stack_set_visible_child_name (_tmp2_, "scanning");
		network_wifi_interface_cancel_scan (self);
		_tmp3_ = self->wifi_device;
		nm_device_wifi_request_scan_async (_tmp3_, NULL, NULL, NULL);
		self->priv->timeout_scan = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 5000, ____lambda8__gsource_func, g_object_ref (self), g_object_unref);
	}
}

static gint
network_wifi_interface_sort_func (NetworkWifiInterface* self,
                                  GtkListBoxRow* r1,
                                  GtkListBoxRow* r2)
{
	gboolean _tmp0_ = FALSE;
	NetworkWifiMenuItem* w1 = NULL;
	NetworkWifiMenuItem* _tmp1_;
	NetworkWifiMenuItem* w2 = NULL;
	NetworkWifiMenuItem* _tmp2_;
	NetworkWifiMenuItem* _tmp3_;
	guint8 _tmp4_;
	guint8 _tmp5_;
	NetworkWifiMenuItem* _tmp6_;
	guint8 _tmp7_;
	guint8 _tmp8_;
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (r1 != NULL, 0);
	g_return_val_if_fail (r2 != NULL, 0);
	if (r1 == NULL) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = r2 == NULL;
	}
	if (_tmp0_) {
		result = 0;
		return result;
	}
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (r1, NETWORK_TYPE_WIFI_MENU_ITEM, NetworkWifiMenuItem));
	w1 = _tmp1_;
	_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (r2, NETWORK_TYPE_WIFI_MENU_ITEM, NetworkWifiMenuItem));
	w2 = _tmp2_;
	_tmp3_ = w2;
	_tmp4_ = network_wifi_menu_item_get_strength (_tmp3_);
	_tmp5_ = _tmp4_;
	_tmp6_ = w1;
	_tmp7_ = network_wifi_menu_item_get_strength (_tmp6_);
	_tmp8_ = _tmp7_;
	result = (gint) (_tmp5_ - _tmp8_);
	_g_object_unref0 (w2);
	_g_object_unref0 (w1);
	return result;
}

NMClient*
network_wifi_interface_get_nm_client (NetworkWifiInterface* self)
{
	NMClient* result;
	NMClient* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_nm_client;
	result = _tmp0_;
	return result;
}

static void
network_wifi_interface_set_nm_client (NetworkWifiInterface* self,
                                      NMClient* value)
{
	NMClient* old_value;
	g_return_if_fail (self != NULL);
	old_value = network_wifi_interface_get_nm_client (self);
	if (old_value != value) {
		NMClient* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_nm_client);
		self->priv->_nm_client = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, network_wifi_interface_properties[NETWORK_WIFI_INTERFACE_NM_CLIENT_PROPERTY]);
	}
}

gboolean
network_wifi_interface_get_hidden_sensitivity (NetworkWifiInterface* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_hidden_sensitivity;
	return result;
}

void
network_wifi_interface_set_hidden_sensitivity (NetworkWifiInterface* self,
                                               gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = network_wifi_interface_get_hidden_sensitivity (self);
	if (old_value != value) {
		self->priv->_hidden_sensitivity = value;
		g_object_notify_by_pspec ((GObject *) self, network_wifi_interface_properties[NETWORK_WIFI_INTERFACE_HIDDEN_SENSITIVITY_PROPERTY]);
	}
}

const gchar*
network_wifi_interface_get_active_ap_name (NetworkWifiInterface* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_active_ap_name;
	result = _tmp0_;
	return result;
}

static void
network_wifi_interface_set_active_ap_name (NetworkWifiInterface* self,
                                           const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = network_wifi_interface_get_active_ap_name (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_active_ap_name);
		self->priv->_active_ap_name = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, network_wifi_interface_properties[NETWORK_WIFI_INTERFACE_ACTIVE_AP_NAME_PROPERTY]);
	}
}

static NetworkWifiInterfacePlaceholderLabel*
network_wifi_interface_placeholder_label_construct (GType object_type,
                                                    const gchar* label)
{
	NetworkWifiInterfacePlaceholderLabel * self = NULL;
	g_return_val_if_fail (label != NULL, NULL);
	self = (NetworkWifiInterfacePlaceholderLabel*) g_object_new (object_type, "label", label, NULL);
	return self;
}

static NetworkWifiInterfacePlaceholderLabel*
network_wifi_interface_placeholder_label_new (const gchar* label)
{
	return network_wifi_interface_placeholder_label_construct (NETWORK_WIFI_INTERFACE_TYPE_PLACEHOLDER_LABEL, label);
}

static GObject *
network_wifi_interface_placeholder_label_constructor (GType type,
                                                      guint n_construct_properties,
                                                      GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	NetworkWifiInterfacePlaceholderLabel * self;
	parent_class = G_OBJECT_CLASS (network_wifi_interface_placeholder_label_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NETWORK_WIFI_INTERFACE_TYPE_PLACEHOLDER_LABEL, NetworkWifiInterfacePlaceholderLabel);
	gtk_label_set_justify ((GtkLabel*) self, GTK_JUSTIFY_CENTER);
	gtk_label_set_max_width_chars ((GtkLabel*) self, 30);
	gtk_label_set_use_markup ((GtkLabel*) self, TRUE);
	gtk_widget_set_visible ((GtkWidget*) self, TRUE);
	g_object_set ((GtkLabel*) self, "wrap-mode", PANGO_WRAP_WORD_CHAR, NULL);
	g_object_set ((GtkLabel*) self, "wrap", TRUE, NULL);
	return obj;
}

static void
network_wifi_interface_placeholder_label_class_init (NetworkWifiInterfacePlaceholderLabelClass * klass,
                                                     gpointer klass_data)
{
	network_wifi_interface_placeholder_label_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->constructor = network_wifi_interface_placeholder_label_constructor;
}

static void
network_wifi_interface_placeholder_label_instance_init (NetworkWifiInterfacePlaceholderLabel * self,
                                                        gpointer klass)
{
}

static GType
network_wifi_interface_placeholder_label_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (NetworkWifiInterfacePlaceholderLabelClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) network_wifi_interface_placeholder_label_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NetworkWifiInterfacePlaceholderLabel), 0, (GInstanceInitFunc) network_wifi_interface_placeholder_label_instance_init, NULL };
	GType network_wifi_interface_placeholder_label_type_id;
	network_wifi_interface_placeholder_label_type_id = g_type_register_static (gtk_label_get_type (), "NetworkWifiInterfacePlaceholderLabel", &g_define_type_info, 0);
	return network_wifi_interface_placeholder_label_type_id;
}

static GType
network_wifi_interface_placeholder_label_get_type (void)
{
	static volatile gsize network_wifi_interface_placeholder_label_type_id__once = 0;
	if (g_once_init_enter (&network_wifi_interface_placeholder_label_type_id__once)) {
		GType network_wifi_interface_placeholder_label_type_id;
		network_wifi_interface_placeholder_label_type_id = network_wifi_interface_placeholder_label_get_type_once ();
		g_once_init_leave (&network_wifi_interface_placeholder_label_type_id__once, network_wifi_interface_placeholder_label_type_id);
	}
	return network_wifi_interface_placeholder_label_type_id__once;
}

static gint
_network_wifi_interface_sort_func_gtk_list_box_sort_func (GtkListBoxRow* row1,
                                                          GtkListBoxRow* row2,
                                                          gpointer self)
{
	gint result;
	result = network_wifi_interface_sort_func ((NetworkWifiInterface*) self, row1, row2);
	return result;
}

static GObject *
network_wifi_interface_constructor (GType type,
                                    guint n_construct_properties,
                                    GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	NetworkWifiInterface * self;
	NetworkWifiInterfacePlaceholderLabel* no_aps = NULL;
	NetworkWifiInterfacePlaceholderLabel* _tmp0_;
	NetworkWifiInterfacePlaceholderLabel* scanning = NULL;
	NetworkWifiInterfacePlaceholderLabel* _tmp1_ = NULL;
	GtkSpinner* spinner = NULL;
	GtkSpinner* _tmp2_;
	GtkSpinner* _tmp3_;
	GtkGrid* scanning_box = NULL;
	GtkGrid* _tmp4_ = NULL;
	GtkGrid* _tmp5_;
	NetworkWifiInterfacePlaceholderLabel* _tmp6_;
	GtkGrid* _tmp7_;
	GtkSpinner* _tmp8_;
	GtkStack* _tmp9_ = NULL;
	GtkStack* _tmp10_;
	NetworkWifiInterfacePlaceholderLabel* _tmp11_;
	GtkStack* _tmp12_;
	GtkGrid* _tmp13_;
	GtkStack* _tmp14_;
	GtkStack* _tmp15_;
	GtkListBox* _tmp16_;
	GtkListBox* _tmp17_;
	GtkListBox* _tmp18_;
	GtkStack* _tmp19_;
	GraniteSwitchModelButton* _tmp20_;
	GraniteSwitchModelButton* _tmp21_;
	GtkStyleContext* _tmp22_;
	GtkScrolledWindow* scrolled_box = NULL;
	GtkScrolledWindow* _tmp23_ = NULL;
	GtkScrolledWindow* _tmp24_;
	GtkListBox* _tmp25_;
	GtkRevealer* _tmp26_;
	GtkRevealer* _tmp27_;
	GtkScrolledWindow* _tmp28_;
	GraniteSwitchModelButton* _tmp29_;
	GtkRevealer* _tmp30_;
	parent_class = G_OBJECT_CLASS (network_wifi_interface_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NETWORK_TYPE_WIFI_INTERFACE, NetworkWifiInterface);
	_tmp0_ = network_wifi_interface_placeholder_label_new (_ ("No Access Points Available"));
	g_object_ref_sink (_tmp0_);
	no_aps = _tmp0_;
	_tmp1_ = network_wifi_interface_placeholder_label_new (_ ("Scanning for Access Points…"));
	gtk_widget_set_halign ((GtkWidget*) _tmp1_, GTK_ALIGN_START);
	gtk_widget_set_hexpand ((GtkWidget*) _tmp1_, TRUE);
	g_object_ref_sink (_tmp1_);
	scanning = _tmp1_;
	_tmp2_ = (GtkSpinner*) gtk_spinner_new ();
	g_object_ref_sink (_tmp2_);
	spinner = _tmp2_;
	_tmp3_ = spinner;
	gtk_spinner_start (_tmp3_);
	_tmp4_ = (GtkGrid*) gtk_grid_new ();
	gtk_grid_set_column_spacing (_tmp4_, 6);
	gtk_widget_set_valign ((GtkWidget*) _tmp4_, GTK_ALIGN_CENTER);
	g_object_ref_sink (_tmp4_);
	scanning_box = _tmp4_;
	_tmp5_ = scanning_box;
	_tmp6_ = scanning;
	gtk_container_add ((GtkContainer*) _tmp5_, (GtkWidget*) _tmp6_);
	_tmp7_ = scanning_box;
	_tmp8_ = spinner;
	gtk_container_add ((GtkContainer*) _tmp7_, (GtkWidget*) _tmp8_);
	_tmp9_ = (GtkStack*) gtk_stack_new ();
	gtk_widget_set_margin_end ((GtkWidget*) _tmp9_, 12);
	gtk_widget_set_margin_start ((GtkWidget*) _tmp9_, 12);
	g_object_ref_sink (_tmp9_);
	_g_object_unref0 (self->priv->placeholder);
	self->priv->placeholder = _tmp9_;
	_tmp10_ = self->priv->placeholder;
	_tmp11_ = no_aps;
	gtk_stack_add_named (_tmp10_, (GtkWidget*) _tmp11_, "no-aps");
	_tmp12_ = self->priv->placeholder;
	_tmp13_ = scanning_box;
	gtk_stack_add_named (_tmp12_, (GtkWidget*) _tmp13_, "scanning");
	_tmp14_ = self->priv->placeholder;
	gtk_stack_set_visible_child_name (_tmp14_, "no-aps");
	_tmp15_ = self->priv->placeholder;
	gtk_widget_show_all ((GtkWidget*) _tmp15_);
	_tmp16_ = (GtkListBox*) gtk_list_box_new ();
	g_object_ref_sink (_tmp16_);
	_g_object_unref0 (self->priv->wifi_list);
	self->priv->wifi_list = _tmp16_;
	_tmp17_ = self->priv->wifi_list;
	gtk_list_box_set_sort_func (_tmp17_, _network_wifi_interface_sort_func_gtk_list_box_sort_func, g_object_ref (self), g_object_unref);
	_tmp18_ = self->priv->wifi_list;
	_tmp19_ = self->priv->placeholder;
	gtk_list_box_set_placeholder (_tmp18_, (GtkWidget*) _tmp19_);
	_tmp20_ = granite_switch_model_button_new ("");
	g_object_ref_sink (_tmp20_);
	_g_object_unref0 (self->priv->wifi_item);
	self->priv->wifi_item = _tmp20_;
	_tmp21_ = self->priv->wifi_item;
	_tmp22_ = gtk_widget_get_style_context ((GtkWidget*) _tmp21_);
	gtk_style_context_add_class (_tmp22_, GRANITE_STYLE_CLASS_H4_LABEL);
	_tmp23_ = (GtkScrolledWindow*) gtk_scrolled_window_new (NULL, NULL);
	g_object_set (_tmp23_, "hscrollbar-policy", GTK_POLICY_NEVER, NULL);
	gtk_scrolled_window_set_max_content_height (_tmp23_, 512);
	gtk_scrolled_window_set_propagate_natural_height (_tmp23_, TRUE);
	g_object_ref_sink (_tmp23_);
	scrolled_box = _tmp23_;
	_tmp24_ = scrolled_box;
	_tmp25_ = self->priv->wifi_list;
	gtk_container_add ((GtkContainer*) _tmp24_, (GtkWidget*) _tmp25_);
	_tmp26_ = (GtkRevealer*) gtk_revealer_new ();
	g_object_ref_sink (_tmp26_);
	_g_object_unref0 (self->priv->revealer);
	self->priv->revealer = _tmp26_;
	_tmp27_ = self->priv->revealer;
	_tmp28_ = scrolled_box;
	gtk_container_add ((GtkContainer*) _tmp27_, (GtkWidget*) _tmp28_);
	gtk_orientable_set_orientation ((GtkOrientable*) self, GTK_ORIENTATION_VERTICAL);
	_tmp29_ = self->priv->wifi_item;
	gtk_box_pack_start ((GtkBox*) self, (GtkWidget*) _tmp29_, TRUE, TRUE, (guint) 0);
	_tmp30_ = self->priv->revealer;
	gtk_box_pack_start ((GtkBox*) self, (GtkWidget*) _tmp30_, TRUE, TRUE, (guint) 0);
	_g_object_unref0 (scrolled_box);
	_g_object_unref0 (scanning_box);
	_g_object_unref0 (spinner);
	_g_object_unref0 (scanning);
	_g_object_unref0 (no_aps);
	return obj;
}

static void
network_wifi_interface_class_init (NetworkWifiInterfaceClass * klass,
                                   gpointer klass_data)
{
	network_wifi_interface_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &NetworkWifiInterface_private_offset);
	((NetworkWidgetNMInterfaceClass *) klass)->update_name = (void (*) (NetworkWidgetNMInterface*, gint)) network_wifi_interface_real_update_name;
	((NetworkWidgetNMInterfaceClass *) klass)->update = (void (*) (NetworkWidgetNMInterface*)) network_wifi_interface_real_update;
	G_OBJECT_CLASS (klass)->get_property = _vala_network_wifi_interface_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_network_wifi_interface_set_property;
	G_OBJECT_CLASS (klass)->constructor = network_wifi_interface_constructor;
	G_OBJECT_CLASS (klass)->finalize = network_wifi_interface_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), NETWORK_WIFI_INTERFACE_NM_CLIENT_PROPERTY, network_wifi_interface_properties[NETWORK_WIFI_INTERFACE_NM_CLIENT_PROPERTY] = g_param_spec_object ("nm-client", "nm-client", "nm-client", nm_client_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NETWORK_WIFI_INTERFACE_HIDDEN_SENSITIVITY_PROPERTY, network_wifi_interface_properties[NETWORK_WIFI_INTERFACE_HIDDEN_SENSITIVITY_PROPERTY] = g_param_spec_boolean ("hidden-sensitivity", "hidden-sensitivity", "hidden-sensitivity", TRUE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NETWORK_WIFI_INTERFACE_ACTIVE_AP_NAME_PROPERTY, network_wifi_interface_properties[NETWORK_WIFI_INTERFACE_ACTIVE_AP_NAME_PROPERTY] = g_param_spec_string ("active-ap-name", "active-ap-name", "active-ap-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
}

static void
network_wifi_interface_instance_init (NetworkWifiInterface * self,
                                      gpointer klass)
{
	GCancellable* _tmp0_;
	self->priv = network_wifi_interface_get_instance_private (self);
	self->priv->_hidden_sensitivity = TRUE;
	self->priv->blank_item = NULL;
	self->priv->timeout_scan = (guint) 0;
	_tmp0_ = g_cancellable_new ();
	self->priv->wifi_scan_cancellable = _tmp0_;
}

static void
network_wifi_interface_finalize (GObject * obj)
{
	NetworkWifiInterface * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NETWORK_TYPE_WIFI_INTERFACE, NetworkWifiInterface);
	_g_object_unref0 (self->priv->_nm_client);
	_g_object_unref0 (self->wifi_device);
	_g_free0 (self->priv->_active_ap_name);
	_g_object_unref0 (self->priv->wifi_item);
	_g_object_unref0 (self->priv->revealer);
	_g_object_unref0 (self->priv->rfkill);
	_g_object_unref0 (self->priv->active_ap);
	_g_object_unref0 (self->priv->wifi_list);
	_g_object_unref0 (self->priv->active_wifi_item);
	_g_object_unref0 (self->priv->blank_item);
	_g_object_unref0 (self->priv->placeholder);
	_g_object_unref0 (self->priv->wifi_scan_cancellable);
	G_OBJECT_CLASS (network_wifi_interface_parent_class)->finalize (obj);
}

static GType
network_wifi_interface_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (NetworkWifiInterfaceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) network_wifi_interface_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NetworkWifiInterface), 0, (GInstanceInitFunc) network_wifi_interface_instance_init, NULL };
	GType network_wifi_interface_type_id;
	network_wifi_interface_type_id = g_type_register_static (NETWORK_TYPE_WIDGET_NM_INTERFACE, "NetworkWifiInterface", &g_define_type_info, 0);
	NetworkWifiInterface_private_offset = g_type_add_instance_private (network_wifi_interface_type_id, sizeof (NetworkWifiInterfacePrivate));
	return network_wifi_interface_type_id;
}

GType
network_wifi_interface_get_type (void)
{
	static volatile gsize network_wifi_interface_type_id__once = 0;
	if (g_once_init_enter (&network_wifi_interface_type_id__once)) {
		GType network_wifi_interface_type_id;
		network_wifi_interface_type_id = network_wifi_interface_get_type_once ();
		g_once_init_leave (&network_wifi_interface_type_id__once, network_wifi_interface_type_id);
	}
	return network_wifi_interface_type_id__once;
}

static void
_vala_network_wifi_interface_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec)
{
	NetworkWifiInterface * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NETWORK_TYPE_WIFI_INTERFACE, NetworkWifiInterface);
	switch (property_id) {
		case NETWORK_WIFI_INTERFACE_NM_CLIENT_PROPERTY:
		g_value_set_object (value, network_wifi_interface_get_nm_client (self));
		break;
		case NETWORK_WIFI_INTERFACE_HIDDEN_SENSITIVITY_PROPERTY:
		g_value_set_boolean (value, network_wifi_interface_get_hidden_sensitivity (self));
		break;
		case NETWORK_WIFI_INTERFACE_ACTIVE_AP_NAME_PROPERTY:
		g_value_set_string (value, network_wifi_interface_get_active_ap_name (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_network_wifi_interface_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec)
{
	NetworkWifiInterface * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NETWORK_TYPE_WIFI_INTERFACE, NetworkWifiInterface);
	switch (property_id) {
		case NETWORK_WIFI_INTERFACE_NM_CLIENT_PROPERTY:
		network_wifi_interface_set_nm_client (self, g_value_get_object (value));
		break;
		case NETWORK_WIFI_INTERFACE_HIDDEN_SENSITIVITY_PROPERTY:
		network_wifi_interface_set_hidden_sensitivity (self, g_value_get_boolean (value));
		break;
		case NETWORK_WIFI_INTERFACE_ACTIVE_AP_NAME_PROPERTY:
		network_wifi_interface_set_active_ap_name (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

