/* WifiMenuItem.c generated by valac 0.56.2, the Vala compiler
 * generated from WifiMenuItem.vala, do not modify */

/*
 * Copyright 2015-2020 elementary, Inc. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Library General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "network.h"
#include <glib.h>
#include <NetworkManager.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <glib-object.h>
#include <pango/pango.h>
#include <glib/gi18n-lib.h>
#include <gdk/gdk.h>

#define NETWORK_WIFI_MENU_ITEM_BASE_ICON_NAME "network-wireless-signal-"
#define NETWORK_WIFI_MENU_ITEM_SYMBOLIC "-symbolic"

enum  {
	NETWORK_WIFI_MENU_ITEM_0_PROPERTY,
	NETWORK_WIFI_MENU_ITEM_SSID_PROPERTY,
	NETWORK_WIFI_MENU_ITEM_STATE_PROPERTY,
	NETWORK_WIFI_MENU_ITEM_STRENGTH_PROPERTY,
	NETWORK_WIFI_MENU_ITEM_AP_PROPERTY,
	NETWORK_WIFI_MENU_ITEM_NUM_PROPERTIES
};
static GParamSpec* network_wifi_menu_item_properties[NETWORK_WIFI_MENU_ITEM_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	NETWORK_WIFI_MENU_ITEM_USER_ACTION_SIGNAL,
	NETWORK_WIFI_MENU_ITEM_NUM_SIGNALS
};
static guint network_wifi_menu_item_signals[NETWORK_WIFI_MENU_ITEM_NUM_SIGNALS] = {0};

struct _NetworkWifiMenuItemPrivate {
	GList* _ap;
	NetworkState _state;
	NMAccessPoint* _tmp_ap;
	GtkRadioButton* radio_button;
	GtkImage* img_strength;
	GtkImage* lock_img;
	GtkImage* error_img;
	GtkSpinner* spinner;
	GtkLabel* label;
};

static gint NetworkWifiMenuItem_private_offset;
static gpointer network_wifi_menu_item_parent_class = NULL;

static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static GSList* network_wifi_menu_item_get_group (NetworkWifiMenuItem* self);
static void network_wifi_menu_item_update (NetworkWifiMenuItem* self);
static void _network_wifi_menu_item_update_g_object_notify (GObject* _sender,
                                                     GParamSpec* pspec,
                                                     gpointer self);
static gboolean __lambda7_ (NetworkWifiMenuItem* self,
                     GtkWidget* b,
                     GdkEventButton* ev);
static gboolean ___lambda7__gtk_widget_button_release_event (GtkWidget* _sender,
                                                      GdkEventButton* event,
                                                      gpointer self);
static void network_wifi_menu_item_update_tmp_ap (NetworkWifiMenuItem* self);
static const gchar* network_wifi_menu_item_get_strength_symbolic_icon (NetworkWifiMenuItem* self);
static void network_wifi_menu_item_hide_item (NetworkWifiMenuItem* self,
                                       GtkWidget* w);
static void network_wifi_menu_item_show_item (NetworkWifiMenuItem* self,
                                       GtkWidget* w);
static void network_wifi_menu_item_finalize (GObject * obj);
static GType network_wifi_menu_item_get_type_once (void);
static void _vala_network_wifi_menu_item_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec);
static void _vala_network_wifi_menu_item_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec);

static inline gpointer
network_wifi_menu_item_get_instance_private (NetworkWifiMenuItem* self)
{
	return G_STRUCT_MEMBER_P (self, NetworkWifiMenuItem_private_offset);
}

static void
_g_object_unref0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
}

static void
_network_wifi_menu_item_update_g_object_notify (GObject* _sender,
                                                GParamSpec* pspec,
                                                gpointer self)
{
	network_wifi_menu_item_update ((NetworkWifiMenuItem*) self);
}

static gboolean
__lambda7_ (NetworkWifiMenuItem* self,
            GtkWidget* b,
            GdkEventButton* ev)
{
	gboolean result;
	g_return_val_if_fail (b != NULL, FALSE);
	g_return_val_if_fail (ev != NULL, FALSE);
	g_signal_emit (self, network_wifi_menu_item_signals[NETWORK_WIFI_MENU_ITEM_USER_ACTION_SIGNAL], 0);
	result = FALSE;
	return result;
}

static gboolean
___lambda7__gtk_widget_button_release_event (GtkWidget* _sender,
                                             GdkEventButton* event,
                                             gpointer self)
{
	gboolean result;
	result = __lambda7_ ((NetworkWifiMenuItem*) self, _sender, event);
	return result;
}

NetworkWifiMenuItem*
network_wifi_menu_item_construct (GType object_type,
                                  NMAccessPoint* ap,
                                  NetworkWifiMenuItem* previous)
{
	NetworkWifiMenuItem * self = NULL;
	GtkLabel* _tmp0_ = NULL;
	GtkRadioButton* _tmp1_ = NULL;
	GtkRadioButton* _tmp2_;
	GtkLabel* _tmp3_;
	GtkImage* _tmp6_ = NULL;
	GtkImage* _tmp7_;
	gchar* _tmp8_;
	GtkImage* _tmp9_ = NULL;
	GtkSpinner* _tmp10_ = NULL;
	GtkSpinner* _tmp11_;
	GtkGrid* grid = NULL;
	GtkGrid* _tmp12_ = NULL;
	GtkRadioButton* _tmp13_;
	GtkSpinner* _tmp14_;
	GtkImage* _tmp15_;
	GtkImage* _tmp16_;
	GtkImage* _tmp17_;
	GtkRadioButton* _tmp18_;
	GtkRadioButton* _tmp19_;
	g_return_val_if_fail (ap != NULL, NULL);
	self = (NetworkWifiMenuItem*) g_object_new (object_type, NULL);
	_tmp0_ = (GtkLabel*) gtk_label_new (NULL);
	gtk_label_set_ellipsize (_tmp0_, PANGO_ELLIPSIZE_MIDDLE);
	g_object_ref_sink (_tmp0_);
	_g_object_unref0 (self->priv->label);
	self->priv->label = _tmp0_;
	_tmp1_ = (GtkRadioButton*) gtk_radio_button_new (NULL);
	gtk_widget_set_hexpand ((GtkWidget*) _tmp1_, TRUE);
	g_object_ref_sink (_tmp1_);
	_g_object_unref0 (self->priv->radio_button);
	self->priv->radio_button = _tmp1_;
	_tmp2_ = self->priv->radio_button;
	_tmp3_ = self->priv->label;
	gtk_container_add ((GtkContainer*) _tmp2_, (GtkWidget*) _tmp3_);
	if (previous != NULL) {
		GtkRadioButton* _tmp4_;
		GSList* _tmp5_;
		_tmp4_ = self->priv->radio_button;
		_tmp5_ = network_wifi_menu_item_get_group (previous);
		gtk_radio_button_set_group (_tmp4_, _tmp5_);
	}
	_tmp6_ = (GtkImage*) gtk_image_new ();
	g_object_set (_tmp6_, "icon-size", (gint) GTK_ICON_SIZE_MENU, NULL);
	g_object_ref_sink (_tmp6_);
	_g_object_unref0 (self->priv->img_strength);
	self->priv->img_strength = _tmp6_;
	_tmp7_ = (GtkImage*) gtk_image_new_from_icon_name ("channel-insecure-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
	g_object_ref_sink (_tmp7_);
	_g_object_unref0 (self->priv->lock_img);
	self->priv->lock_img = _tmp7_;
	_tmp8_ = g_strdup (_ ("Unable to connect"));
	_tmp9_ = (GtkImage*) gtk_image_new_from_icon_name ("process-error-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp9_, _tmp8_);
	_g_free0 (_tmp8_);
	g_object_ref_sink (_tmp9_);
	_g_object_unref0 (self->priv->error_img);
	self->priv->error_img = _tmp9_;
	_tmp10_ = (GtkSpinner*) gtk_spinner_new ();
	gtk_widget_set_no_show_all ((GtkWidget*) _tmp10_, TRUE);
	gtk_widget_set_visible ((GtkWidget*) _tmp10_, FALSE);
	g_object_ref_sink (_tmp10_);
	_g_object_unref0 (self->priv->spinner);
	self->priv->spinner = _tmp10_;
	_tmp11_ = self->priv->spinner;
	gtk_spinner_start (_tmp11_);
	_tmp12_ = (GtkGrid*) gtk_grid_new ();
	gtk_grid_set_column_spacing (_tmp12_, 6);
	g_object_ref_sink (_tmp12_);
	grid = _tmp12_;
	_tmp13_ = self->priv->radio_button;
	gtk_container_add ((GtkContainer*) grid, (GtkWidget*) _tmp13_);
	_tmp14_ = self->priv->spinner;
	gtk_container_add ((GtkContainer*) grid, (GtkWidget*) _tmp14_);
	_tmp15_ = self->priv->error_img;
	gtk_container_add ((GtkContainer*) grid, (GtkWidget*) _tmp15_);
	_tmp16_ = self->priv->lock_img;
	gtk_container_add ((GtkContainer*) grid, (GtkWidget*) _tmp16_);
	_tmp17_ = self->priv->img_strength;
	gtk_container_add ((GtkContainer*) grid, (GtkWidget*) _tmp17_);
	(self->priv->_ap == NULL) ? NULL : (self->priv->_ap = (_g_list_free__g_object_unref0_ (self->priv->_ap), NULL));
	self->priv->_ap = NULL;
	network_wifi_menu_item_add_ap (self, ap);
	g_signal_connect_object ((GObject*) self, "notify::state", (GCallback) _network_wifi_menu_item_update_g_object_notify, self, 0);
	_tmp18_ = self->priv->radio_button;
	g_signal_connect_object ((GObject*) _tmp18_, "notify::active", (GCallback) _network_wifi_menu_item_update_g_object_notify, self, 0);
	_tmp19_ = self->priv->radio_button;
	g_signal_connect_object ((GtkWidget*) _tmp19_, "button-release-event", (GCallback) ___lambda7__gtk_widget_button_release_event, self, 0);
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) grid);
	_g_object_unref0 (grid);
	return self;
}

NetworkWifiMenuItem*
network_wifi_menu_item_new (NMAccessPoint* ap,
                            NetworkWifiMenuItem* previous)
{
	return network_wifi_menu_item_construct (NETWORK_TYPE_WIFI_MENU_ITEM, ap, previous);
}

/**
     * Only used for an item which is not displayed: hacky way to have no radio button selected.
     **/
NetworkWifiMenuItem*
network_wifi_menu_item_construct_blank (GType object_type)
{
	NetworkWifiMenuItem * self = NULL;
	GtkRadioButton* _tmp0_;
	self = (NetworkWifiMenuItem*) g_object_new (object_type, NULL);
	_tmp0_ = (GtkRadioButton*) gtk_radio_button_new (NULL);
	g_object_ref_sink (_tmp0_);
	_g_object_unref0 (self->priv->radio_button);
	self->priv->radio_button = _tmp0_;
	return self;
}

NetworkWifiMenuItem*
network_wifi_menu_item_new_blank (void)
{
	return network_wifi_menu_item_construct_blank (NETWORK_TYPE_WIFI_MENU_ITEM);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
network_wifi_menu_item_update_tmp_ap (NetworkWifiMenuItem* self)
{
	guint8 strength = 0U;
	GList* _tmp0_;
	g_return_if_fail (self != NULL);
	strength = (guint8) 0;
	_tmp0_ = self->priv->_ap;
	{
		GList* ap_collection = NULL;
		GList* ap_it = NULL;
		ap_collection = _tmp0_;
		for (ap_it = ap_collection; ap_it != NULL; ap_it = ap_it->next) {
			NMAccessPoint* _tmp1_;
			NMAccessPoint* ap = NULL;
			_tmp1_ = _g_object_ref0 ((NMAccessPoint*) ap_it->data);
			ap = _tmp1_;
			{
				NMAccessPoint* _tmp2_ = NULL;
				NMAccessPoint* _tmp3_;
				NMAccessPoint* _tmp6_;
				NMAccessPoint* _tmp7_;
				_tmp3_ = ap;
				if (strength > nm_access_point_get_strength (_tmp3_)) {
					NMAccessPoint* _tmp4_;
					_tmp4_ = self->priv->_tmp_ap;
					_tmp2_ = _tmp4_;
				} else {
					NMAccessPoint* _tmp5_;
					_tmp5_ = ap;
					_tmp2_ = _tmp5_;
				}
				_tmp6_ = _g_object_ref0 (_tmp2_);
				_g_object_unref0 (self->priv->_tmp_ap);
				self->priv->_tmp_ap = _tmp6_;
				_tmp7_ = ap;
				strength = MAX (strength, nm_access_point_get_strength (_tmp7_));
				_g_object_unref0 (ap);
			}
		}
	}
}

void
network_wifi_menu_item_set_active (NetworkWifiMenuItem* self,
                                   gboolean active)
{
	GtkRadioButton* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->radio_button;
	gtk_toggle_button_set_active ((GtkToggleButton*) _tmp0_, active);
}

static GSList*
network_wifi_menu_item_get_group (NetworkWifiMenuItem* self)
{
	GtkRadioButton* _tmp0_;
	GSList* _tmp1_;
	GSList* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->radio_button;
	_tmp1_ = gtk_radio_button_get_group (_tmp0_);
	result = _tmp1_;
	return result;
}

static void
network_wifi_menu_item_update (NetworkWifiMenuItem* self)
{
	GtkLabel* _tmp0_;
	NMAccessPoint* _tmp1_;
	NMAccessPoint* _tmp2_;
	GBytes* _tmp3_;
	gsize _tmp4_ = 0;
	guint8* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	GtkImage* _tmp8_;
	const gchar* _tmp9_;
	GtkImage* _tmp10_;
	NM80211ApSecurityFlags flags = 0U;
	NMAccessPoint* _tmp11_;
	NMAccessPoint* _tmp12_;
	NMAccessPoint* _tmp13_;
	NMAccessPoint* _tmp14_;
	gboolean is_secured = FALSE;
	GtkImage* _tmp15_;
	GtkImage* _tmp16_;
	GtkImage* _tmp17_;
	gboolean _tmp18_;
	gboolean _tmp19_;
	GtkImage* _tmp20_;
	GtkSpinner* _tmp21_;
	NetworkState _tmp22_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->label;
	_tmp1_ = network_wifi_menu_item_get_ap (self);
	_tmp2_ = _tmp1_;
	_tmp3_ = nm_access_point_get_ssid (_tmp2_);
	_tmp5_ = g_bytes_get_data (_tmp3_, &_tmp4_);
	_tmp6_ = nm_utils_ssid_to_utf8 (_tmp5_, (gsize) _tmp4_);
	_tmp7_ = _tmp6_;
	gtk_label_set_label (_tmp0_, _tmp7_);
	_g_free0 (_tmp7_);
	_tmp8_ = self->priv->img_strength;
	_tmp9_ = network_wifi_menu_item_get_strength_symbolic_icon (self);
	g_object_set (_tmp8_, "icon-name", _tmp9_, NULL);
	_tmp10_ = self->priv->img_strength;
	gtk_widget_show_all ((GtkWidget*) _tmp10_);
	_tmp11_ = network_wifi_menu_item_get_ap (self);
	_tmp12_ = _tmp11_;
	_tmp13_ = network_wifi_menu_item_get_ap (self);
	_tmp14_ = _tmp13_;
	flags = nm_access_point_get_wpa_flags (_tmp12_) | nm_access_point_get_rsn_flags (_tmp14_);
	is_secured = FALSE;
	if ((flags & NM_802_11_AP_SEC_GROUP_WEP40) == NM_802_11_AP_SEC_GROUP_WEP40) {
		is_secured = TRUE;
		gtk_widget_set_tooltip_text ((GtkWidget*) self, _ ("40/64-bit WEP encrypted"));
	} else {
		if ((flags & NM_802_11_AP_SEC_GROUP_WEP104) == NM_802_11_AP_SEC_GROUP_WEP104) {
			is_secured = TRUE;
			gtk_widget_set_tooltip_text ((GtkWidget*) self, _ ("104/128-bit WEP encrypted"));
		} else {
			if ((flags & NM_802_11_AP_SEC_KEY_MGMT_SAE) == NM_802_11_AP_SEC_KEY_MGMT_SAE) {
				is_secured = TRUE;
				gtk_widget_set_tooltip_text ((GtkWidget*) self, _ ("WPA3 encrypted"));
			} else {
				if ((flags & NM_802_11_AP_SEC_KEY_MGMT_PSK) == NM_802_11_AP_SEC_KEY_MGMT_PSK) {
					is_secured = TRUE;
					gtk_widget_set_tooltip_text ((GtkWidget*) self, _ ("WPA encrypted"));
				} else {
					if (flags != NM_802_11_AP_SEC_NONE) {
						is_secured = TRUE;
						gtk_widget_set_tooltip_text ((GtkWidget*) self, _ ("Encrypted"));
					} else {
						gtk_widget_set_tooltip_text ((GtkWidget*) self, _ ("Unsecured"));
					}
				}
			}
		}
	}
	_tmp15_ = self->priv->lock_img;
	gtk_widget_set_visible ((GtkWidget*) _tmp15_, !is_secured);
	_tmp16_ = self->priv->lock_img;
	_tmp17_ = self->priv->lock_img;
	_tmp18_ = gtk_widget_get_visible ((GtkWidget*) _tmp17_);
	_tmp19_ = _tmp18_;
	gtk_widget_set_no_show_all ((GtkWidget*) _tmp16_, !_tmp19_);
	_tmp20_ = self->priv->error_img;
	network_wifi_menu_item_hide_item (self, (GtkWidget*) _tmp20_);
	_tmp21_ = self->priv->spinner;
	network_wifi_menu_item_hide_item (self, (GtkWidget*) _tmp21_);
	_tmp22_ = self->priv->_state;
	switch (_tmp22_) {
		case NETWORK_STATE_FAILED_WIFI:
		{
			GtkImage* _tmp23_;
			_tmp23_ = self->priv->error_img;
			network_wifi_menu_item_show_item (self, (GtkWidget*) _tmp23_);
			break;
		}
		case NETWORK_STATE_CONNECTING_WIFI:
		{
			GtkSpinner* _tmp24_;
			GtkRadioButton* _tmp25_;
			gboolean _tmp26_;
			gboolean _tmp27_;
			_tmp24_ = self->priv->spinner;
			network_wifi_menu_item_show_item (self, (GtkWidget*) _tmp24_);
			_tmp25_ = self->priv->radio_button;
			_tmp26_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp25_);
			_tmp27_ = _tmp26_;
			if (!_tmp27_) {
				g_critical ("WifiMenuItem.vala:172: An access point is being connected but not acti" \
"ve.");
			}
			break;
		}
		default:
		break;
	}
}

static void
network_wifi_menu_item_show_item (NetworkWifiMenuItem* self,
                                  GtkWidget* w)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (w != NULL);
	gtk_widget_set_visible (w, TRUE);
	_tmp0_ = gtk_widget_get_visible (w);
	_tmp1_ = _tmp0_;
	gtk_widget_set_no_show_all (w, !_tmp1_);
}

static void
network_wifi_menu_item_hide_item (NetworkWifiMenuItem* self,
                                  GtkWidget* w)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (w != NULL);
	gtk_widget_set_visible (w, FALSE);
	_tmp0_ = gtk_widget_get_visible (w);
	_tmp1_ = _tmp0_;
	gtk_widget_set_no_show_all (w, !_tmp1_);
	gtk_widget_hide (w);
}

void
network_wifi_menu_item_add_ap (NetworkWifiMenuItem* self,
                               NMAccessPoint* ap)
{
	NMAccessPoint* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (ap != NULL);
	_tmp0_ = _g_object_ref0 (ap);
	self->priv->_ap = g_list_append (self->priv->_ap, _tmp0_);
	network_wifi_menu_item_update_tmp_ap (self);
	network_wifi_menu_item_update (self);
}

static const gchar*
network_wifi_menu_item_get_strength_symbolic_icon (NetworkWifiMenuItem* self)
{
	guint8 _tmp0_;
	guint8 _tmp1_;
	const gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = network_wifi_menu_item_get_strength (self);
	_tmp1_ = _tmp0_;
	if (((gint) _tmp1_) < 30) {
		result = NETWORK_WIFI_MENU_ITEM_BASE_ICON_NAME "weak" NETWORK_WIFI_MENU_ITEM_SYMBOLIC;
		return result;
	} else {
		guint8 _tmp2_;
		guint8 _tmp3_;
		_tmp2_ = network_wifi_menu_item_get_strength (self);
		_tmp3_ = _tmp2_;
		if (((gint) _tmp3_) < 55) {
			result = NETWORK_WIFI_MENU_ITEM_BASE_ICON_NAME "ok" NETWORK_WIFI_MENU_ITEM_SYMBOLIC;
			return result;
		} else {
			guint8 _tmp4_;
			guint8 _tmp5_;
			_tmp4_ = network_wifi_menu_item_get_strength (self);
			_tmp5_ = _tmp4_;
			if (((gint) _tmp5_) < 80) {
				result = NETWORK_WIFI_MENU_ITEM_BASE_ICON_NAME "good" NETWORK_WIFI_MENU_ITEM_SYMBOLIC;
				return result;
			} else {
				result = NETWORK_WIFI_MENU_ITEM_BASE_ICON_NAME "excellent" NETWORK_WIFI_MENU_ITEM_SYMBOLIC;
				return result;
			}
		}
	}
}

static GList*
vala_g_list_remove_full (GList* self,
                         gconstpointer data,
                         GFreeFunc func)
{
	GList* l = NULL;
	GList* result;
	l = self;
	while (TRUE) {
		GList* _tmp0_;
		GList* _tmp1_;
		gconstpointer _tmp2_;
		_tmp0_ = l;
		if (!(_tmp0_ != NULL)) {
			break;
		}
		_tmp1_ = l;
		_tmp2_ = ((GList*) _tmp1_)->data;
		if (_tmp2_ != data) {
			GList* _tmp3_;
			GList* _tmp4_;
			_tmp3_ = l;
			_tmp4_ = ((GList*) _tmp3_)->next;
			l = _tmp4_;
		} else {
			GList* _tmp5_;
			gconstpointer _tmp6_;
			GList* _tmp7_;
			_tmp5_ = l;
			_tmp6_ = ((GList*) _tmp5_)->data;
			func (_tmp6_);
			_tmp7_ = l;
			self = g_list_delete_link (self, (GList*) _tmp7_);
			break;
		}
	}
	result = self;
	return result;
}

gboolean
network_wifi_menu_item_remove_ap (NetworkWifiMenuItem* self,
                                  NMAccessPoint* ap)
{
	GList* _tmp0_;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (ap != NULL, FALSE);
	self->priv->_ap = vala_g_list_remove_full (self->priv->_ap, ap, _g_object_unref0_);
	network_wifi_menu_item_update_tmp_ap (self);
	_tmp0_ = self->priv->_ap;
	result = g_list_length (_tmp0_) > ((guint) 0);
	return result;
}

GBytes*
network_wifi_menu_item_get_ssid (NetworkWifiMenuItem* self)
{
	GBytes* result;
	NMAccessPoint* _tmp0_;
	GBytes* _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_tmp_ap;
	_tmp1_ = nm_access_point_get_ssid (_tmp0_);
	result = _tmp1_;
	return result;
}

NetworkState
network_wifi_menu_item_get_state (NetworkWifiMenuItem* self)
{
	NetworkState result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_state;
	return result;
}

void
network_wifi_menu_item_set_state (NetworkWifiMenuItem* self,
                                  NetworkState value)
{
	NetworkState old_value;
	g_return_if_fail (self != NULL);
	old_value = network_wifi_menu_item_get_state (self);
	if (old_value != value) {
		self->priv->_state = value;
		g_object_notify_by_pspec ((GObject *) self, network_wifi_menu_item_properties[NETWORK_WIFI_MENU_ITEM_STATE_PROPERTY]);
	}
}

guint8
network_wifi_menu_item_get_strength (NetworkWifiMenuItem* self)
{
	guint8 result;
	guint8 strength = 0U;
	GList* _tmp0_;
	g_return_val_if_fail (self != NULL, 0U);
	strength = (guint8) 0;
	_tmp0_ = self->priv->_ap;
	{
		GList* ap_collection = NULL;
		GList* ap_it = NULL;
		ap_collection = _tmp0_;
		for (ap_it = ap_collection; ap_it != NULL; ap_it = ap_it->next) {
			NMAccessPoint* _tmp1_;
			NMAccessPoint* ap = NULL;
			_tmp1_ = _g_object_ref0 ((NMAccessPoint*) ap_it->data);
			ap = _tmp1_;
			{
				NMAccessPoint* _tmp2_;
				_tmp2_ = ap;
				strength = MAX (strength, nm_access_point_get_strength (_tmp2_));
				_g_object_unref0 (ap);
			}
		}
	}
	result = strength;
	return result;
}

NMAccessPoint*
network_wifi_menu_item_get_ap (NetworkWifiMenuItem* self)
{
	NMAccessPoint* result;
	NMAccessPoint* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_tmp_ap;
	result = _tmp0_;
	return result;
}

static void
network_wifi_menu_item_base_init (NetworkWifiMenuItemClass * klass)
{
	gtk_widget_class_set_css_name (GTK_WIDGET_CLASS (klass), GTK_STYLE_CLASS_MENUITEM);
}

static void
network_wifi_menu_item_class_init (NetworkWifiMenuItemClass * klass,
                                   gpointer klass_data)
{
	network_wifi_menu_item_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &NetworkWifiMenuItem_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_network_wifi_menu_item_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_network_wifi_menu_item_set_property;
	G_OBJECT_CLASS (klass)->finalize = network_wifi_menu_item_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), NETWORK_WIFI_MENU_ITEM_SSID_PROPERTY, network_wifi_menu_item_properties[NETWORK_WIFI_MENU_ITEM_SSID_PROPERTY] = g_param_spec_boxed ("ssid", "ssid", "ssid", G_TYPE_BYTES, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NETWORK_WIFI_MENU_ITEM_STATE_PROPERTY, network_wifi_menu_item_properties[NETWORK_WIFI_MENU_ITEM_STATE_PROPERTY] = g_param_spec_enum ("state", "state", "state", NETWORK_TYPE_STATE, NETWORK_STATE_DISCONNECTED, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NETWORK_WIFI_MENU_ITEM_STRENGTH_PROPERTY, network_wifi_menu_item_properties[NETWORK_WIFI_MENU_ITEM_STRENGTH_PROPERTY] = g_param_spec_uchar ("strength", "strength", "strength", 0, G_MAXUINT8, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NETWORK_WIFI_MENU_ITEM_AP_PROPERTY, network_wifi_menu_item_properties[NETWORK_WIFI_MENU_ITEM_AP_PROPERTY] = g_param_spec_object ("ap", "ap", "ap", nm_access_point_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	network_wifi_menu_item_signals[NETWORK_WIFI_MENU_ITEM_USER_ACTION_SIGNAL] = g_signal_new ("user-action", NETWORK_TYPE_WIFI_MENU_ITEM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}

static void
network_wifi_menu_item_instance_init (NetworkWifiMenuItem * self,
                                      gpointer klass)
{
	self->priv = network_wifi_menu_item_get_instance_private (self);
	self->priv->_state = NETWORK_STATE_DISCONNECTED;
}

static void
network_wifi_menu_item_finalize (GObject * obj)
{
	NetworkWifiMenuItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NETWORK_TYPE_WIFI_MENU_ITEM, NetworkWifiMenuItem);
	(self->priv->_ap == NULL) ? NULL : (self->priv->_ap = (_g_list_free__g_object_unref0_ (self->priv->_ap), NULL));
	_g_object_unref0 (self->priv->_tmp_ap);
	_g_object_unref0 (self->priv->radio_button);
	_g_object_unref0 (self->priv->img_strength);
	_g_object_unref0 (self->priv->lock_img);
	_g_object_unref0 (self->priv->error_img);
	_g_object_unref0 (self->priv->spinner);
	_g_object_unref0 (self->priv->label);
	G_OBJECT_CLASS (network_wifi_menu_item_parent_class)->finalize (obj);
}

static GType
network_wifi_menu_item_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (NetworkWifiMenuItemClass), (GBaseInitFunc) network_wifi_menu_item_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) network_wifi_menu_item_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NetworkWifiMenuItem), 0, (GInstanceInitFunc) network_wifi_menu_item_instance_init, NULL };
	GType network_wifi_menu_item_type_id;
	network_wifi_menu_item_type_id = g_type_register_static (gtk_list_box_row_get_type (), "NetworkWifiMenuItem", &g_define_type_info, 0);
	NetworkWifiMenuItem_private_offset = g_type_add_instance_private (network_wifi_menu_item_type_id, sizeof (NetworkWifiMenuItemPrivate));
	return network_wifi_menu_item_type_id;
}

GType
network_wifi_menu_item_get_type (void)
{
	static volatile gsize network_wifi_menu_item_type_id__once = 0;
	if (g_once_init_enter (&network_wifi_menu_item_type_id__once)) {
		GType network_wifi_menu_item_type_id;
		network_wifi_menu_item_type_id = network_wifi_menu_item_get_type_once ();
		g_once_init_leave (&network_wifi_menu_item_type_id__once, network_wifi_menu_item_type_id);
	}
	return network_wifi_menu_item_type_id__once;
}

static void
_vala_network_wifi_menu_item_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec)
{
	NetworkWifiMenuItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NETWORK_TYPE_WIFI_MENU_ITEM, NetworkWifiMenuItem);
	switch (property_id) {
		case NETWORK_WIFI_MENU_ITEM_SSID_PROPERTY:
		g_value_set_boxed (value, network_wifi_menu_item_get_ssid (self));
		break;
		case NETWORK_WIFI_MENU_ITEM_STATE_PROPERTY:
		g_value_set_enum (value, network_wifi_menu_item_get_state (self));
		break;
		case NETWORK_WIFI_MENU_ITEM_STRENGTH_PROPERTY:
		g_value_set_uchar (value, network_wifi_menu_item_get_strength (self));
		break;
		case NETWORK_WIFI_MENU_ITEM_AP_PROPERTY:
		g_value_set_object (value, network_wifi_menu_item_get_ap (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_network_wifi_menu_item_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec)
{
	NetworkWifiMenuItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NETWORK_TYPE_WIFI_MENU_ITEM, NetworkWifiMenuItem);
	switch (property_id) {
		case NETWORK_WIFI_MENU_ITEM_STATE_PROPERTY:
		network_wifi_menu_item_set_state (self, g_value_get_enum (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

